/*
 * AC3 audio decoder
 *
 * Copyright 2000 Kuba Winnicki <bw@skytaxi.pl>
 */

#include <stdio.h>
#include <string.h>
#include "ac3.h"

using namespace std;

uint_8* AC3_Decoder::__in_data = NULL;
int AC3_Decoder::alreadyRead = 0;
const int AC3_Decoder::CHUNK_SIZE = 2048;

AC3_Decoder::AC3_Decoder( WAVEFORMATEX* wf, void* extension )
{
	in_fmt = *wf;
	ac3_config.fill_buffer_callback = fillBuffer;
	ac3_config.num_output_ch = 2;
	ac3_config.flags = 0;

	ac3_init( &ac3_config );
	m_status = 1;
}

int
AC3_Decoder::Convert( unsigned char* in_data, Unsigned in_size,
		      unsigned char* out_data, Unsigned out_size,
		      Unsigned* size_read, Unsigned* size_written )
{
	if( in_data == 0 )
		return -1;

	if( out_data == 0 )
		return -1;

	__in_data = in_data;
	alreadyRead = 0;
	ac3_frame = ac3_decode_frame();

	memcpy( out_data, ac3_frame->audio_data, 1024 * 6 );

	if( size_read )
		*size_read = alreadyRead;

	if( size_written )
		*size_written = 1024 * 6;

	return 0;
}

void
AC3_Decoder::fillBuffer( uint_8** start, uint_8** end )
{
	static uint_8 buf[ CHUNK_SIZE ];

	memcpy( buf, __in_data, CHUNK_SIZE );

	*start = buf;
	*end= *start + CHUNK_SIZE;
	alreadyRead = CHUNK_SIZE;
}

