#include "assetedit.h"
#include "assetpopup.h"
#include "awindow.h"
#include "awindowgui.h"
#include "clipedit.h"
#include "mainindexes.h"
#include "mwindow.h"
#include "vwindow.h"
#include "vwindowgui.h"

AssetPopup::AssetPopup(MWindow *mwindow, AWindowGUI *gui)
 : BC_PopupMenu(0, 
		0, 
		0, 
		"", 
		0)
{
	this->mwindow = mwindow;
	this->gui = gui;
}

AssetPopup::~AssetPopup()
{
}

void AssetPopup::create_objects()
{
	add_item(info = new AssetPopupInfo(mwindow, this));
	add_item(index = new AssetPopupBuildIndex(mwindow, this));
	add_item(view = new AssetPopupView(mwindow, this));
}

int AssetPopup::update(Asset *asset)
{
	this->asset = asset;
	this->clip = 0;
	return 0;
}

int AssetPopup::update(EDL *clip)
{
	this->clip = clip;
	this->asset = 0;
	return 0;
}









AssetPopupInfo::AssetPopupInfo(MWindow *mwindow, AssetPopup *popup)
 : BC_MenuItem("Info...")
{
	this->mwindow = mwindow;
	this->popup = popup;
}

AssetPopupInfo::~AssetPopupInfo()
{
}

int AssetPopupInfo::handle_event()
{
	if(popup->asset)
	{
		if(popup->gui->awindow->asset_edit->running() && popup->gui->awindow->asset_edit->window)
		{
			popup->gui->awindow->asset_edit->window->raise_window();
			popup->gui->awindow->asset_edit->window->flush();
		}
		else
		{
			popup->gui->awindow->asset_edit->edit_asset(popup->asset);
		}
	}
	else
	if(popup->clip)
	{
		popup->gui->awindow->clip_edit->edit_clip(popup->clip);
	}
	return 1;
}







AssetPopupBuildIndex::AssetPopupBuildIndex(MWindow *mwindow, AssetPopup *popup)
 : BC_MenuItem("Rebuild index")
{
	this->mwindow = mwindow;
	this->popup = popup;
}

AssetPopupBuildIndex::~AssetPopupBuildIndex()
{
}

int AssetPopupBuildIndex::handle_event()
{
	mwindow->rebuild_index(popup->asset);
	return 1;
}







AssetPopupView::AssetPopupView(MWindow *mwindow, AssetPopup *popup)
 : BC_MenuItem("View")
{
	this->mwindow = mwindow;
	this->popup = popup;
}

AssetPopupView::~AssetPopupView()
{
}

int AssetPopupView::handle_event()
{
	mwindow->vwindow->gui->lock_window();

	if(popup->asset)
		mwindow->vwindow->change_source(popup->asset);
	else
	if(popup->clip)
		mwindow->vwindow->change_source(popup->clip);

	mwindow->vwindow->gui->unlock_window();
	return 1;
}
