#ifndef AUTOMATION_H
#define AUTOMATION_H

#include "arraylist.h"
#include "bezierautos.inc"
#include "edl.inc"
#include "filexml.inc"
#include "floatautos.inc"
#include "intautos.inc"
#include "maxchannels.h"
#include "module.inc"
#include "panautos.inc"
#include "intautos.inc"
#include "track.inc"

class Automation
{
public:
	Automation(EDL *edl, Track *track);
	virtual ~Automation();

	virtual int create_objects();
	virtual Automation& operator=(Automation& automation);
	virtual void copy_from(Automation *automation);
	int load(FileXML *file, int &current_plugin, int &current_channel);
	int copy(long start, long end, FileXML *xml);
	virtual void dump();
	virtual int direct_copy_possible(long start, int direction);
	virtual int direct_copy_possible_derived(long start, int direction) { return 1; };
	void clear(long start, long end);
	void paste_silence(long start, long end);
	void insert_track(Automation *automation, 
		long start_unit, 
		long length_units,
		int replace_default);
	void resample(double old_rate, double new_rate);

	IntAutos *play_autos;
	IntAutos *mute_autos;
	BezierAutos *camera_autos;
	BezierAutos *projector_autos;
	FloatAutos *fade_autos;
	PanAutos *pan_autos;
// Overlay mode
	IntAutos *mode_autos;


	EDL *edl;
	Track *track;
};

#endif
