#include "cpanel.h"
#include "cwindowgui.h"
#include "cwindowtool.h"
#include "edl.h"
#include "edlsession.h"
#include "mbuttons.h"
#include "mwindow.h"
#include "theme.h"


CPanel::CPanel(MWindow *mwindow, CWindowGUI *subwindow, int x, int y, int w, int h)
{
	this->mwindow = mwindow;
	this->subwindow = subwindow;
	this->x = x;
	this->y = y;
	this->w = w;
	this->h = h;
}

CPanel::~CPanel()
{
}

int CPanel::create_objects()
{
	int x = this->x, y = this->y;
// 	subwindow->add_subwindow(operation[CWINDOW_RECTSELECTION] = new CPanelRectSelection(mwindow, this, x, y));
// 	y += operation[CWINDOW_RECTSELECTION]->get_h();
// 	subwindow->add_subwindow(operation[CWINDOW_CIRCLESELECTION] = new CPanelCirSelection(mwindow, this, x, y));
// 	y += operation[CWINDOW_CIRCLESELECTION]->get_h();
//	subwindow->add_subwindow(operation[CWINDOW_TRANSLATE] = new CPanelMove(mwindow, this, x, y));
//	y += operation[CWINDOW_TRANSLATE]->get_h();
// 	subwindow->add_subwindow(operation[CWINDOW_ERASE] = new CPanelErase(mwindow, this, x, y));
// 	y += operation[CWINDOW_ERASE]->get_h();
// 	subwindow->add_subwindow(operation[CWINDOW_ANTIERASE] = new CPanelAntierase(mwindow, this, x, y));
// 	y += operation[CWINDOW_ANTIERASE]->get_h();
//printf("CPanel 1\n");
	subwindow->add_subwindow(operation[CWINDOW_PROTECT] = new CPanelProtect(mwindow, this, x, y));
//printf("CPanel 1\n");
	y += operation[CWINDOW_PROTECT]->get_h();
//printf("CPanel 1\n");
	subwindow->add_subwindow(operation[CWINDOW_ZOOM] = new CPanelMagnify(mwindow, this, x, y));
//printf("CPanel 1\n");
	y += operation[CWINDOW_ZOOM]->get_h();
//printf("CPanel 1\n");
	subwindow->add_subwindow(operation[CWINDOW_CAMERA] = new CPanelCamera(mwindow, this, x, y));
//printf("CPanel 1\n");
	y += operation[CWINDOW_CAMERA]->get_h();
//printf("CPanel 1\n");
	subwindow->add_subwindow(operation[CWINDOW_PROJECTOR] = new CPanelProj(mwindow, this, x, y));
	y += operation[CWINDOW_PROJECTOR]->get_h();
	subwindow->add_subwindow(operation[CWINDOW_CROP] = new CPanelCrop(mwindow, this, x, y));
	y += operation[CWINDOW_CROP]->get_h();
	subwindow->add_subwindow(operation[CWINDOW_TOOL_WINDOW] = new CPanelToolWindow(mwindow, this, x, y));
//	y += operation[CWINDOW_TOOL_WINDOW]->get_h();
//	subwindow->add_subwindow(operation[CWINDOW_SHOW_METERS] = new MeterShow(mwindow, subwindow->meters, x, y));
	return 0;
}

void CPanel::reposition_buttons(int x, int y)
{
	this->x = x;
	this->y = y;
	
	for(int i = 0; i < CPANEL_OPERATIONS; i++)
	{
		operation[i]->reposition_window(x, y);
		y += operation[i]->get_h();
	}
}


void CPanel::set_operation(int value)
{
	for(int i = 0; i < CPANEL_OPERATIONS; i++)
	{
		if(i == CWINDOW_TOOL_WINDOW)
		{
			operation[i]->update(mwindow->edl->session->tool_window);
		}
		else
// 		if(i == CWINDOW_SHOW_METERS)
// 		{
// 			operation[i]->update(mwindow->edl->session->cwindow_meter);
// 		}
// 		else
		{
			if(i != value) 
				operation[i]->update(0);
			else
				operation[i]->update(1);
		}
	}

	if(mwindow->edl->session->cwindow_operation != value)
	{
		mwindow->edl->session->cwindow_operation = value;
		subwindow->set_operation(value);
	}
}



CPanelRectSelection::CPanelRectSelection(MWindow *mwindow, CPanel *gui, int x, int y)
 : BC_Toggle(x, 
 	y, 
 	mwindow->theme->rectselection_data, 
	mwindow->edl->session->cwindow_operation == 0 /*WINDOW_RECTSELECTION*/)
{
	this->mwindow = mwindow;
	this->gui = gui;
	set_tooltip("Select rectangle");
}
CPanelRectSelection::~CPanelRectSelection()
{
}
int CPanelRectSelection::handle_event()
{
//	gui->set_operation(CWINDOW_RECTSELECTION);
	return 1;
}

CPanelCirSelection::CPanelCirSelection(MWindow *mwindow, CPanel *gui, int x, int y)
 : BC_Toggle(x, 
 	y, 
	mwindow->theme->cirselection_data, 
	mwindow->edl->session->cwindow_operation == 0 /*CWINDOW_CIRCLESELECTION*/)
{
	this->mwindow = mwindow;
	this->gui = gui;
	set_tooltip("Select circle");
}
CPanelCirSelection::~CPanelCirSelection()
{
}
int CPanelCirSelection::handle_event()
{
//	gui->set_operation(CWINDOW_CIRCLESELECTION);
	return 1;
}

CPanelMove::CPanelMove(MWindow *mwindow, CPanel *gui, int x, int y)
 : BC_Toggle(x, 
 	y, 
	mwindow->theme->move_data, 
	0 /* mwindow->edl->session->cwindow_operation == CWINDOW_TRANSLATE */)
{
	this->mwindow = mwindow;
	this->gui = gui;
	set_tooltip("Translation");
}
CPanelMove::~CPanelMove()
{
}
int CPanelMove::handle_event()
{
//	gui->set_operation(CWINDOW_TRANSLATE);
	return 1;
}


CPanelErase::CPanelErase(MWindow *mwindow, CPanel *gui, int x, int y)
 : BC_Toggle(x, 
 	y, 
	mwindow->theme->erase_data, 
	mwindow->edl->session->cwindow_operation == 0/*CWINDOW_ERASE*/)
{
	this->mwindow = mwindow;
	this->gui = gui;
	set_tooltip("Erase");
}
CPanelErase::~CPanelErase()
{
}
int CPanelErase::handle_event()
{
//	gui->set_operation(CWINDOW_ERASE);
	return 1;
}


CPanelAntierase::CPanelAntierase(MWindow *mwindow, CPanel *gui, int x, int y)
 : BC_Toggle(x, 
 	y, 
	mwindow->theme->antierase_data, 
	mwindow->edl->session->cwindow_operation == 0 /*CWINDOW_ANTIERASE*/)
{
	this->mwindow = mwindow;
	this->gui = gui;
	set_tooltip("Antierase");
}
CPanelAntierase::~CPanelAntierase()
{
}
int CPanelAntierase::handle_event()
{
//	gui->set_operation(CWINDOW_ANTIERASE);
	return 1;
}



CPanelProtect::CPanelProtect(MWindow *mwindow, CPanel *gui, int x, int y)
 : BC_Toggle(x, 
 	y, 
	mwindow->theme->protect_data, 
	mwindow->edl->session->cwindow_operation == CWINDOW_PROTECT)
{
	this->mwindow = mwindow;
	this->gui = gui;
	set_tooltip("Protect video from changes");
}
CPanelProtect::~CPanelProtect()
{
}
int CPanelProtect::handle_event()
{
	gui->set_operation(CWINDOW_PROTECT);
	return 1;
}






CPanelMagnify::CPanelMagnify(MWindow *mwindow, CPanel *gui, int x, int y)
 : BC_Toggle(x, 
 	y, 
	mwindow->theme->magnify_data, 
	mwindow->edl->session->cwindow_operation == CWINDOW_ZOOM)
{
	this->mwindow = mwindow;
	this->gui = gui;
	set_tooltip("Zoom view");
}
CPanelMagnify::~CPanelMagnify()
{
}
int CPanelMagnify::handle_event()
{
	gui->set_operation(CWINDOW_ZOOM);
	return 1;
}


CPanelCamera::CPanelCamera(MWindow *mwindow, CPanel *gui, int x, int y)
 : BC_Toggle(x, 
 	y, 
	mwindow->theme->camera_data, 
	mwindow->edl->session->cwindow_operation == CWINDOW_CAMERA)
{
	this->mwindow = mwindow;
	this->gui = gui;
	set_tooltip("Adjust camera automation");
}
CPanelCamera::~CPanelCamera()
{
}
int CPanelCamera::handle_event()
{
	gui->set_operation(CWINDOW_CAMERA);
	return 1;
}


CPanelProj::CPanelProj(MWindow *mwindow, CPanel *gui, int x, int y)
 : BC_Toggle(x, 
 	y, 
	mwindow->theme->proj_data, 
	mwindow->edl->session->cwindow_operation == CWINDOW_PROJECTOR)
{
	this->mwindow = mwindow;
	this->gui = gui;
	set_tooltip("Adjust projector automation");
}
CPanelProj::~CPanelProj()
{
}
int CPanelProj::handle_event()
{
	gui->set_operation(CWINDOW_PROJECTOR);
	return 1;
}


CPanelCrop::CPanelCrop(MWindow *mwindow, CPanel *gui, int x, int y)
 : BC_Toggle(x, 
 	y, 
	mwindow->theme->crop_data, 
	mwindow->edl->session->cwindow_operation == CWINDOW_CROP)
{
	this->mwindow = mwindow;
	this->gui = gui;
	set_tooltip("Crop a layer or output");
}
CPanelCrop::~CPanelCrop()
{
}
int CPanelCrop::handle_event()
{
	gui->set_operation(CWINDOW_CROP);
	return 1;
}




CPanelToolWindow::CPanelToolWindow(MWindow *mwindow, CPanel *gui, int x, int y)
 : BC_Toggle(x, 
 	y, 
	mwindow->theme->tool_data, 
	mwindow->edl->session->tool_window)
{
	this->mwindow = mwindow;
	this->gui = gui;
	set_tooltip("Show tool info");
}
CPanelToolWindow::~CPanelToolWindow()
{
}
int CPanelToolWindow::handle_event()
{
	mwindow->edl->session->tool_window = get_value();
	gui->subwindow->tool_panel->update_show_window();
	return 1;
}

