#include "cplayback.h"
#include "ctracking.h"
#include "cwindow.h"
#include "cwindowgui.h"
#include "edl.h"
#include "edlsession.h"
#include "localsession.h"
#include "mainclock.h"
#include "mwindow.h"
#include "mwindowgui.h"
#include "trackcanvas.h"
#include "zoombar.h"

CTracking::CTracking(MWindow *mwindow, CWindow *cwindow)
 : Tracking(mwindow)
{
	this->cwindow = cwindow;
}

CTracking::~CTracking()
{
}

PlaybackEngine* CTracking::get_playback_engine()
{
	return cwindow->playback_engine;
}

int CTracking::start_playback(double new_position)
{
	mwindow->gui->cursor->playing_back = 1;

	Tracking::start_playback(new_position);
	return 0;
}

int CTracking::stop_playback()
{
	mwindow->gui->cursor->playing_back = 0;


	Tracking::stop_playback();
	return 0;
}


void CTracking::update_tracker(double position)
{
//printf("CTracking::update_tracker 1 %f\n", position);
// Update mwindow cursor
	mwindow->gui->lock_window();
	mwindow->edl->local_session->selectionstart = 
		mwindow->edl->local_session->selectionend = 
		position;
	mwindow->gui->cursor->update();
//printf("CTracking::update_tracker 1 %d\n", mwindow->gui->cursor->visible);
	mwindow->gui->mainclock->update(position);
	mwindow->gui->zoombar->update();
	mwindow->gui->canvas->flash();
	mwindow->gui->flush();
	mwindow->gui->unlock_window();
//printf("CTracking::update_tracker 2\n");

// Update cwindow cursor
	cwindow->gui->lock_window();
	cwindow->gui->slider->update(position);
//	cwindow->gui->clock->update(position);
	cwindow->gui->unlock_window();

//printf("CTracking::update_tracker 3\n");
	update_meters((long)(position * mwindow->edl->session->sample_rate));
//printf("CTracking::update_tracker 4\n");
}

void CTracking::draw()
{
}
