#include "defaulttheme.h"
#include "edl.inc"
#include "overlayframe.h"
#include "vframe.h"


#define BUILD_BUTTON(data, \
	png_overlay, \
	up_vframe, \
	hi_vframe, \
	dn_vframe) \
{ \
	VFrame default_data(png_overlay); \
	data = new VFrame*[3]; \
	data[0] = new VFrame(0, default_data.get_w(), default_data.get_h(), BC_RGBA8888); \
	data[1] = new VFrame(0, default_data.get_w(), default_data.get_h(), BC_RGBA8888); \
	data[2] = new VFrame(0, default_data.get_w(), default_data.get_h(), BC_RGBA8888); \
	data[0]->copy_from(up_vframe); \
	data[1]->copy_from(hi_vframe); \
	data[2]->copy_from(dn_vframe); \
	for(int i = 0; i < 3; i++) \
		overlay.overlay(data[i],  \
			&default_data,  \
			0,  \
			0,  \
			default_data.get_w(),  \
			default_data.get_h(),  \
			0,  \
			0,  \
			data[i]->get_w(),  \
			data[i]->get_h(),  \
			1,  \
			TRANSFER_NORMAL, \
			NEAREST_NEIGHBOR); \
}

#define BUILD_TOGGLE(data, \
	png_overlay, \
	up_vframe, \
	hi_vframe, \
	checked_vframe, \
	dn_vframe, \
	checkedhi_vframe) \
{ \
	VFrame default_data(png_overlay); \
	data = new VFrame*[5]; \
	data[0] = new VFrame(0, default_data.get_w(), default_data.get_h(), BC_RGBA8888); \
	data[1] = new VFrame(0, default_data.get_w(), default_data.get_h(), BC_RGBA8888); \
	data[2] = new VFrame(0, default_data.get_w(), default_data.get_h(), BC_RGBA8888); \
	data[3] = new VFrame(0, default_data.get_w(), default_data.get_h(), BC_RGBA8888); \
	data[4] = new VFrame(0, default_data.get_w(), default_data.get_h(), BC_RGBA8888); \
	data[0]->copy_from(up_vframe); \
	data[1]->copy_from(hi_vframe); \
	data[2]->copy_from(checked_vframe); \
	data[3]->copy_from(dn_vframe); \
	data[4]->copy_from(checkedhi_vframe); \
	for(int i = 0; i < 5; i++) \
		overlay.overlay(data[i],  \
			&default_data,  \
			0,  \
			0,  \
			default_data.get_w(),  \
			default_data.get_h(),  \
			0,  \
			0,  \
			data[i]->get_w(),  \
			data[i]->get_h(),  \
			1,  \
			TRANSFER_NORMAL, \
			NEAREST_NEIGHBOR); \
}


void DefaultTheme::construct1()
{
	OverlayFrame overlay;

//printf("DefaultTheme::construct1 1\n");
// Edit Panel
#include "theme/append_dn_png.h"
#include "theme/append_up_png.h"
#include "theme/append_hi_png.h"
#include "theme/fit_up_png.h"
#include "theme/fit_dn_png.h"
#include "theme/fit_hi_png.h"
#include "theme/insert_dn_png.h"
#include "theme/insert_up_png.h"
#include "theme/insert_hi_png.h"
#include "theme/transition_dn_png.h"
#include "theme/transition_up_png.h"
#include "theme/transition_hi_png.h"
#include "theme/presentation_dn_png.h"
#include "theme/presentation_up_png.h"
#include "theme/presentation_hi_png.h"
#include "theme/undo_dn_png.h"
#include "theme/undo_hi_png.h"
#include "theme/undo_up_png.h"
#include "theme/redo_dn_png.h"
#include "theme/redo_hi_png.h"
#include "theme/redo_up_png.h"

//printf("DefaultTheme::construct1 1\n");



// Resource window
#include "theme/deletedisk_up_png.h"
#include "theme/deletedisk_hi_png.h"
#include "theme/deletedisk_dn_png.h"
#include "theme/awindow/deletebin_up_png.h"
#include "theme/awindow/deletebin_hi_png.h"
#include "theme/awindow/deletebin_dn_png.h"
#include "theme/awindow/newbin_up_png.h"
#include "theme/awindow/newbin_hi_png.h"
#include "theme/awindow/newbin_dn_png.h"
#include "theme/awindow/renamebin_up_png.h"
#include "theme/awindow/renamebin_hi_png.h"
#include "theme/awindow/renamebin_dn_png.h"
#include "theme/deleteproject_up_png.h"
#include "theme/deleteproject_hi_png.h"
#include "theme/deleteproject_dn_png.h"
#include "theme/infoasset_up_png.h"
#include "theme/infoasset_hi_png.h"
#include "theme/infoasset_dn_png.h"
#include "theme/redrawindex_up_png.h"
#include "theme/redrawindex_hi_png.h"
#include "theme/redrawindex_dn_png.h"
#include "theme/pasteasset_up_png.h"
#include "theme/pasteasset_hi_png.h"
#include "theme/pasteasset_dn_png.h"
#include "theme/appendasset_up_png.h"
#include "theme/appendasset_hi_png.h"
#include "theme/appendasset_dn_png.h"
#include "theme/viewasset_up_png.h"
#include "theme/viewasset_hi_png.h"
#include "theme/viewasset_dn_png.h"

//printf("DefaultTheme::construct1 1\n");



//printf("DefaultTheme::construct1 1\n");

// Editing panel
#include "theme/editpanel/extract_dn_png.h"
#include "theme/editpanel/extract_hi_png.h"
#include "theme/editpanel/extract_up_png.h"
#include "theme/editpanel/lift_dn_png.h"
#include "theme/editpanel/lift_hi_png.h"
#include "theme/editpanel/lift_up_png.h"

#include "theme2/editpanel_up_png.h"
#include "theme2/editpanel_hi_png.h"
#include "theme2/editpanel_dn_png.h"
#include "theme2/editpanel_checked_png.h"
#include "theme2/editpanel_checkedhi_png.h"
// Editing panel
	VFrame editpanel_up(editpanel_up_png);
	VFrame editpanel_hi(editpanel_hi_png);
	VFrame editpanel_dn(editpanel_dn_png);
	VFrame editpanel_checked(editpanel_checked_png);
	VFrame editpanel_checkedhi(editpanel_checkedhi_png);

#include "theme2/inpoint_png.h"
	BUILD_BUTTON(out_data, inpoint_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/outpoint_png.h"
	BUILD_BUTTON(in_data, outpoint_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/splice_png.h"
	BUILD_BUTTON(splice_data, splice_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/overwrite_png.h"
	BUILD_BUTTON(overwrite_data, overwrite_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/label_png.h"
	BUILD_BUTTON(labelbutton_data, label_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/prevlabel_png.h"
	BUILD_BUTTON(prevlabel_data, prevlabel_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/nextlabel_png.h"
	BUILD_BUTTON(nextlabel_data, nextlabel_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/cut_png.h"
	BUILD_BUTTON(cut_data, cut_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/copy_png.h"
	BUILD_BUTTON(copy_data, copy_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/paste_png.h"
	BUILD_BUTTON(paste_data, paste_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/fit_png.h"
	BUILD_BUTTON(fit_data, fit_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/undo_png.h"
	BUILD_BUTTON(undo_data, undo_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/redo_png.h"
	BUILD_BUTTON(redo_data, redo_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/clearinpoint_png.h"
	BUILD_BUTTON(indelete_data, clearinpoint_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/clearoutpoint_png.h"
	BUILD_BUTTON(outdelete_data, clearoutpoint_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/toclip_png.h"
	BUILD_BUTTON(toclip_data, toclip_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/over_png.h"
	BUILD_BUTTON(over_button, over_png, &editpanel_up, &editpanel_hi, &editpanel_dn);

//printf("DefaultTheme::construct1 1\n");
#include "theme2/arrow_png.h"
	BUILD_TOGGLE(arrow_data, arrow_png, &editpanel_up, &editpanel_hi, &editpanel_checked, &editpanel_dn, &editpanel_checkedhi);
#include "theme2/ibeam_png.h"
	BUILD_TOGGLE(ibeam_data, ibeam_png, &editpanel_up, &editpanel_hi, &editpanel_checked, &editpanel_dn, &editpanel_checkedhi);
#include "theme2/autokeyframe_png.h"
	BUILD_TOGGLE(autokeyframe_data, autokeyframe_png, &editpanel_up, &editpanel_hi, &editpanel_checked, &editpanel_dn, &editpanel_checkedhi);


	static VFrame *default_lift_data[] = 
	{
		new VFrame(lift_up_png), new VFrame(lift_hi_png), new VFrame(lift_dn_png)
	};
	static VFrame *default_extract_data[] = 
	{
		new VFrame(extract_up_png), new VFrame(extract_hi_png), new VFrame(extract_dn_png)
	};
	static VFrame *default_append_data[] = 
	{
		new VFrame(append_up_png), new VFrame(append_hi_png), new VFrame(append_dn_png)
	};
	static VFrame *default_insert_data[] = 
	{
		new VFrame(insert_up_png), new VFrame(insert_hi_png), new VFrame(insert_dn_png)
	};
	static VFrame *default_transition_data[] = 
	{
		new VFrame(transition_up_png), new VFrame(transition_hi_png), new VFrame(transition_dn_png)
	};
	static VFrame *default_presentation_data[] = 
	{
		new VFrame(presentation_up_png), new VFrame(presentation_hi_png), new VFrame(presentation_dn_png)
	};

//printf("DefaultTheme::construct1 1\n");
	append_data = default_append_data;
	transition_data = default_transition_data;
	insert_data = default_insert_data;
	presentation_data = default_presentation_data;
	lift_data = 	 default_lift_data;
	extract_data  =  default_extract_data;

//printf("DefaultTheme::construct1 1\n");




// Compositing panel
// Compositing
#include "theme/antierase_dn_png.h"
#include "theme/antierase_up_png.h"
#include "theme/antierase_hi_png.h"
#include "theme/antierase_checkedhi_png.h"
#include "theme/antierase_checked_png.h"
#include "theme/cirselection_hi_png.h"
#include "theme/cirselection_up_png.h"
#include "theme/cirselection_dn_png.h"
#include "theme/cirselection_checkedhi_png.h"
#include "theme/cirselection_checked_png.h"
#include "theme/erase_hi_png.h"
#include "theme/erase_up_png.h"
#include "theme/erase_dn_png.h"
#include "theme/erase_checkedhi_png.h"
#include "theme/erase_checked_png.h"
#include "theme/rectselection_hi_png.h"
#include "theme/rectselection_up_png.h"
#include "theme/rectselection_dn_png.h"
#include "theme/rectselection_checkedhi_png.h"
#include "theme/rectselection_checked_png.h"
#include "theme/move_dn_png.h"
#include "theme/move_up_png.h"
#include "theme/move_hi_png.h"
#include "theme/move_checkedhi_png.h"
#include "theme/move_checked_png.h"

//printf("DefaultTheme::construct1 1\n");
	static VFrame *default_cirselection_data[] = 
	{
		new VFrame(cirselection_up_png), new VFrame(cirselection_hi_png), new VFrame(cirselection_checked_png), new VFrame(cirselection_dn_png), new VFrame(cirselection_checkedhi_png)
	};
	static VFrame *default_rectselection_data[] = 
	{
		new VFrame(rectselection_up_png), new VFrame(rectselection_hi_png), new VFrame(rectselection_checked_png), new VFrame(rectselection_dn_png), new VFrame(rectselection_checkedhi_png)
	};
	static VFrame *default_move_data[] = 
	{
		new VFrame(move_up_png), new VFrame(move_hi_png), new VFrame(move_checked_png), new VFrame(move_dn_png), new VFrame(move_checkedhi_png)
	};
	static VFrame *default_erase_data[] = 
	{
		new VFrame(erase_up_png), new VFrame(erase_hi_png), new VFrame(erase_checked_png), new VFrame(erase_dn_png), new VFrame(erase_checkedhi_png)
	};
	static VFrame *default_antierase_data[] = 
	{
		new VFrame(antierase_up_png), new VFrame(antierase_hi_png), new VFrame(antierase_checked_png), new VFrame(antierase_dn_png), new VFrame(antierase_checkedhi_png)
	};



//printf("DefaultTheme::construct1 1\n");




	static VFrame *default_deletedisk_data[] = 
	{
		new VFrame(deletedisk_up_png), new VFrame(deletedisk_hi_png), new VFrame(deletedisk_dn_png)
	};
	static VFrame *default_deletebin_data[] = 
	{
		new VFrame(deletebin_up_png), new VFrame(deletebin_hi_png), new VFrame(deletebin_dn_png)
	};
	static VFrame *default_newbin_data[] = 
	{
		new VFrame(newbin_up_png), new VFrame(newbin_hi_png), new VFrame(newbin_dn_png)
	};
	static VFrame *default_renamebin_data[] = 
	{
		new VFrame(renamebin_up_png), new VFrame(renamebin_hi_png), new VFrame(renamebin_dn_png)
	};
	static VFrame *default_deleteproject_data[] = 
	{
		new VFrame(deleteproject_up_png), new VFrame(deleteproject_hi_png), new VFrame(deleteproject_dn_png)
	};
	static VFrame *default_infoasset_data[] = 
	{
		new VFrame(infoasset_up_png), new VFrame(infoasset_hi_png), new VFrame(infoasset_dn_png)
	};
	static VFrame *default_redrawindex_data[] = 
	{
		new VFrame(redrawindex_up_png), new VFrame(redrawindex_hi_png), new VFrame(redrawindex_dn_png)
	};
	static VFrame *default_pasteasset_data[] = 
	{
		new VFrame(pasteasset_up_png), new VFrame(pasteasset_hi_png), new VFrame(pasteasset_dn_png)
	};
	static VFrame *default_appendasset_data[] = 
	{
		new VFrame(appendasset_up_png), new VFrame(appendasset_hi_png), new VFrame(appendasset_dn_png)
	};
	static VFrame *default_viewasset_data[] = 
	{
		new VFrame(viewasset_up_png), new VFrame(viewasset_hi_png), new VFrame(viewasset_dn_png)
	};



//printf("DefaultTheme::construct1 1\n");



// Recording

//printf("DefaultTheme::construct1 1\n");
// Resource window
	deletedisk_data = default_deletedisk_data;
	deletebin_data = default_deletebin_data;
	newbin_data = default_newbin_data;
	renamebin_data = default_renamebin_data;
	deleteproject_data = default_deleteproject_data;
	infoasset_data = default_infoasset_data;
	redrawindex_data = default_redrawindex_data;
	pasteasset_data = default_pasteasset_data;
	appendasset_data = default_appendasset_data;
	viewasset_data = default_viewasset_data;

// Compositing panel
#include "theme2/camera_png.h"
	BUILD_TOGGLE(camera_data, camera_png, &editpanel_up, &editpanel_hi, &editpanel_checked, &editpanel_dn, &editpanel_checkedhi);
#include "theme2/projector_png.h"
	BUILD_TOGGLE(proj_data, projector_png, &editpanel_up, &editpanel_hi, &editpanel_checked, &editpanel_dn, &editpanel_checkedhi);
#include "theme2/magnify_png.h"
	BUILD_TOGGLE(magnify_data, magnify_png, &editpanel_up, &editpanel_hi, &editpanel_checked, &editpanel_dn, &editpanel_checkedhi);
#include "theme2/crop_png.h"
	BUILD_TOGGLE(crop_data, crop_png, &editpanel_up, &editpanel_hi, &editpanel_checked, &editpanel_dn, &editpanel_checkedhi);
#include "theme2/toolwindow_png.h"
	BUILD_TOGGLE(tool_data, toolwindow_png, &editpanel_up, &editpanel_hi, &editpanel_checked, &editpanel_dn, &editpanel_checkedhi);
#include "theme2/magnify_png.h"
	BUILD_BUTTON(magnify_button_data, magnify_png, &editpanel_up, &editpanel_hi, &editpanel_dn);
#include "theme2/protect_png.h"
	BUILD_TOGGLE(protect_data, protect_png, &editpanel_up, &editpanel_hi, &editpanel_checked, &editpanel_dn, &editpanel_checkedhi);
#include "theme2/show_meters_png.h"
	BUILD_TOGGLE(show_meters, show_meters_png,  &editpanel_up, &editpanel_hi, &editpanel_checked, &editpanel_dn, &editpanel_checkedhi);



//printf("DefaultTheme::construct1 1\n");
	move_data = default_move_data;
	erase_data = default_erase_data;
	antierase_data = default_antierase_data;
	cirselection_data = default_cirselection_data;
	rectselection_data = default_rectselection_data;
//printf("DefaultTheme::construct1 1\n");
}
