#include "defaulttheme.h"
#include "overlayframe.h"
#include "vframe.h"

#define BUILD_TRANSPORT(data, \
	png_overlay, \
	bg_data, \
	third) \
{ \
	VFrame default_data(png_overlay); \
	data = new VFrame*[3]; \
	data[0] = new VFrame(0, default_data.get_w(), default_data.get_h(), BC_RGBA8888); \
	data[1] = new VFrame(0, default_data.get_w(), default_data.get_h(), BC_RGBA8888); \
	data[2] = new VFrame(0, default_data.get_w(), default_data.get_h(), BC_RGBA8888); \
	for(int i = 0; i < 3; i++) \
	{ \
		overlay.overlay(data[i],  \
			bg_data[i],  \
			default_data.get_w() * third,  \
			0,  \
			default_data.get_w() * third + default_data.get_w(),  \
			bg_data[i]->get_h(),  \
			0,  \
			0,  \
			data[i]->get_w(),  \
			data[i]->get_h(),  \
			1,  \
			TRANSFER_NORMAL, \
			NEAREST_NEIGHBOR); \
		overlay.overlay(data[i],  \
			&default_data,  \
			0,  \
			0,  \
			default_data.get_w(),  \
			default_data.get_h(),  \
			0,  \
			0,  \
			data[i]->get_w(),  \
			data[i]->get_h(),  \
			1,  \
			TRANSFER_NORMAL, \
			NEAREST_NEIGHBOR); \
	} \
}

#include "theme/asset_append_dn_png.h"  
#include "theme/asset_append_hi_png.h"  
#include "theme/asset_append_up_png.h"  
#include "theme/asset_disk_dn_png.h"    
#include "theme/asset_disk_hi_png.h"    
#include "theme/asset_disk_up_png.h"    
#include "theme/asset_index_dn_png.h"   
#include "theme/asset_index_hi_png.h"
#include "theme/asset_index_up_png.h"
#include "theme/asset_info_dn_png.h"
#include "theme/asset_info_hi_png.h"
#include "theme/asset_info_up_png.h"
#include "theme/asset_project_dn_png.h"
#include "theme/asset_project_hi_png.h"
#include "theme/asset_project_up_png.h"
#include "theme/chain_dn_png.h"  
#include "theme/chain_hi_png.h"  
#include "theme/chain_up_png.h"
#include "theme/options_dn_png.h"
#include "theme/options_hi_png.h"
#include "theme/options_up_png.h"
#include "theme/over_dn_png.h"
#include "theme/over_up_png.h"
#include "theme/over_uphi_png.h"

VFrame *default_asset_append[] = 
{
	new VFrame(asset_append_up_png), new VFrame(asset_append_hi_png), new VFrame(asset_append_dn_png)
};

VFrame *default_asset_disk[] = 
{
	new VFrame(asset_disk_up_png), new VFrame(asset_disk_hi_png), new VFrame(asset_disk_dn_png)
};

VFrame *default_asset_index[] = 
{
	new VFrame(asset_index_up_png), new VFrame(asset_index_hi_png), new VFrame(asset_index_dn_png)
};

VFrame *default_asset_info[] = 
{
	new VFrame(asset_info_up_png), new VFrame(asset_info_hi_png), new VFrame(asset_info_dn_png)
};

VFrame *default_asset_project[] = 
{
	new VFrame(asset_project_up_png), new VFrame(asset_project_hi_png), new VFrame(asset_project_dn_png)
};

VFrame *default_over_button[] = 
{
	new VFrame(over_up_png), new VFrame(over_uphi_png), new VFrame(over_dn_png)
};

VFrame *default_browse_button[] = 
{
	new VFrame(over_up_png), new VFrame(over_uphi_png), new VFrame(over_dn_png)
};

VFrame *default_options_data[] = 
{
	new VFrame(options_hi_png), new VFrame(options_up_png), new VFrame(options_dn_png)
};

VFrame *default_chain_data[] = 
{
	new VFrame(chain_hi_png), new VFrame(chain_up_png), new VFrame(chain_dn_png)
};




void DefaultTheme::construct2()
{
// Labels
	OverlayFrame overlay;

	over_button = default_over_button;

#include "theme/labels/in_checked_png.h"
#include "theme/labels/in_checkedhi_png.h"
#include "theme/labels/in_dn_png.h"
#include "theme/labels/in_hi_png.h"
#include "theme/labels/in_up_png.h"
#include "theme/labels/label_checked_png.h"
#include "theme/labels/label_checkedhi_png.h"
#include "theme/labels/labeltoggle_dn_png.h"
#include "theme/labels/labeltoggle_up_png.h"
#include "theme/labels/labeltoggle_uphi_png.h"
#include "theme/labels/out_checked_png.h"
#include "theme/labels/out_checkedhi_png.h"
#include "theme/labels/out_dn_png.h"
#include "theme/labels/out_hi_png.h"
#include "theme/labels/out_up_png.h"

	static VFrame* default_labeltoggle[] = 
	{
		new VFrame(labeltoggle_up_png), new VFrame(labeltoggle_uphi_png), new VFrame(label_checked_png), new VFrame(labeltoggle_dn_png), new VFrame(label_checkedhi_png)
	};
	static VFrame* default_outpoint[] = 
	{
		new VFrame(in_up_png), new VFrame(in_hi_png), new VFrame(in_checked_png), new VFrame(in_dn_png), new VFrame(in_checkedhi_png)
	};
	
	static VFrame* default_inpoint[] = 
	{
		new VFrame(out_up_png), new VFrame(out_hi_png), new VFrame(out_checked_png), new VFrame(out_dn_png), new VFrame(out_checkedhi_png)
	};
	
	
	label_toggle = default_labeltoggle;
	in_point = default_inpoint;
	out_point = default_outpoint;

// Play transport
#include "theme2/transportup_png.h"
#include "theme2/transporthi_png.h"
#include "theme2/transportdn_png.h"
	VFrame *transport_bg[] = 
	{
		new VFrame(transportup_png), new VFrame(transporthi_png), new VFrame(transportdn_png)
	};

#include "theme2/rewind_png.h"
	BUILD_TRANSPORT(rewind_data,
		rewind_png,
		transport_bg, 
		0);
#include "theme2/fastrev_png.h"
	BUILD_TRANSPORT(fastrev_data,
		fastrev_png,
		transport_bg, 
		1);
#include "theme2/framerev_png.h"
	BUILD_TRANSPORT(framerev_data,
		framerev_png,
		transport_bg, 
		1);
#include "theme2/reverse_png.h"
	BUILD_TRANSPORT(reverse_data,
		reverse_png,
		transport_bg, 
		1);
#include "theme2/stop_png.h"
	BUILD_TRANSPORT(stop_data,
		stop_png,
		transport_bg, 
		1);
	BUILD_TRANSPORT(stoprec_data,
		stop_png,
		transport_bg, 
		2);
#include "theme2/framefwd_png.h"
	BUILD_TRANSPORT(framefwd_data,
		framefwd_png,
		transport_bg, 
		1);
#include "theme2/play_png.h"
	BUILD_TRANSPORT(forward_data,
		play_png,
		transport_bg, 
		1);
#include "theme2/framefwd_png.h"
	BUILD_TRANSPORT(framefwd_data,
		framefwd_png,
		transport_bg, 
		1);
#include "theme2/fastfwd_png.h"
	BUILD_TRANSPORT(fastfwd_data,
		fastfwd_png,
		transport_bg, 
		1);
#include "theme2/end_png.h"
	BUILD_TRANSPORT(end_data,
		end_png,
		transport_bg, 
		2);
#include "theme2/record_png.h"
	BUILD_TRANSPORT(rec_data,
		record_png,
		transport_bg, 
		1);
#include "theme2/duplex_png.h"
	BUILD_TRANSPORT(duplex_data,
		duplex_png,
		transport_bg, 
		1);
#include "theme2/singleframe_png.h"
	BUILD_TRANSPORT(recframe_data,
		singleframe_png,
		transport_bg, 
		1);

#include "theme/playtransport/pause_dn_png.h"
#include "theme/playtransport/pause_dnhi_png.h"
#include "theme/playtransport/pause_hi_png.h"
#include "theme/playtransport/pause_up_png.h"



	static VFrame* default_pause_data[] = 
	{
		new VFrame(pause_up_png), new VFrame(pause_hi_png), new VFrame(pause_dn_png)
	};

	static VFrame* default_paused_data[] = 
	{
		new VFrame(pause_dn_png), new VFrame(pause_dnhi_png), new VFrame(pause_up_png)
	};

	pause_data = default_pause_data;
	paused_data = default_paused_data;

}
