#include "edit.h"
#include "editpopup.h"
#include "mwindow.h"
#include "mwindowgui.h"
#include "plugindialog.h"
#include "trackcanvas.h"

EditPopup::EditPopup(MWindow *mwindow, MWindowGUI *gui)
 : BC_PopupMenu(0, 
		0, 
		0, 
		"", 
		0)
{
	this->mwindow = mwindow;
	this->gui = gui;
}

EditPopup::~EditPopup()
{
}

void EditPopup::create_objects()
{
	add_item(new EditAttachEffect(mwindow, this));
}

int EditPopup::update(Edit *edit)
{
	this->edit = edit;
	return 0;
}









EditAttachEffect::EditAttachEffect(MWindow *mwindow, EditPopup *popup)
 : BC_MenuItem("Attach effect...")
{
	this->mwindow = mwindow;
	this->popup = popup;
	dialog_thread = new PluginDialogThread(mwindow);
}

EditAttachEffect::~EditAttachEffect()
{
	delete dialog_thread;
}

int EditAttachEffect::handle_event()
{
	dialog_thread->start_window(popup->edit->track,
		popup->edit, 
		0, 
		PROGRAM_NAME ": Attach Effect");
	return 1;
}



