#ifndef EDITS_H
#define EDITS_H


#include "assets.inc"
#include "edl.inc"
#include "guicast.h"
#include "edit.h"
#include "filexml.inc"
#include "linklist.h"
#include "mwindow.inc"
#include "track.inc"
#include "transition.inc"

// Generic list of edits of something

class Edits : public List<Edit>
{
public:
	Edits(EDL *edl, Track *track);
	virtual ~Edits();	

	virtual Edits& operator=(Edits& edits);
// Editing
	void insert_edits(Edits *edits, long position);
	void insert_asset(Asset *asset, long length, long sample, int track_number);
	void split_edit(Edit *edit, long position);
// Create a blank edit in the native data format
	virtual Edit* create_edit() { return 0; };
// Insert a 0 length edit at the position
	Edit* insert_new_edit(long sample);
	int save(FileXML *xml, char *output_path);
	int copy(long start, long end, FileXML *xml, char *output_path);
	int clear(long start, long end);
	int paste_silence(long start, long end);
	void resample(double old_rate, double new_rate);

	EDL *edl;
	Track *track;










// ============================= initialization commands ====================
	Edits() { printf("default edits constructor called\n"); };
	Edits(MWindow *mwindow, Track *track);

// ================================== file operations

	int load(FileXML *xml, int track_offset);
	int load_edit(FileXML *xml, long &startproject, int track_offset);

	virtual Edit* append_new_edit() {};
	virtual Edit* insert_edit_after(Edit *previous_edit) { return 0; };
	virtual int load_edit_properties(FileXML *xml) {};


// ==================================== accounting

	Edit* editof(long position, int direction);
// Return an edit if position is over an edit and the edit has a source file
	Edit* get_playable_edit(long position);
	long total_length();
	long length();         // end position of last edit

// ==================================== editing

// inserts space at the desired location and returns the edit before the space
// fills end of track if range is after track
	Edit* insert(long start, long lengthsamples);
	int clear_handle(long start, long end);
	int modify_handles(double oldposition, 
		double newposition, 
		int currentend, 
		int edit_mode);
	int paste(long start, long end, long total_length, FileXML *xml);
	int paste_transition(long startproject, long endproject, Transition *transition);
	Edit* paste_edit_base(long start, long end, long startsource, long length, Asset *asset);
	virtual int optimize();

	MWindow *mwindow;

private:
	virtual int clone_derived(Edit* new_edit, Edit* old_edit) {};
};



#endif
