#ifndef FILE_INC
#define FILE_INC

// Return values for open_file
#define FILE_OK 0
#define FILE_NOT_FOUND 1
#define FILE_UNRECOGNIZED_CODEC 2
#define FILE_IS_XML 3

#define FILE_UNKNOWN   0
#define FILE_PCM  	   1
#define FILE_WAV  	   2
#define FILE_MOV  	   3
#define FILE_PNG  	   4
#define FILE_JPEG 	   5
#define FILE_TIFF 	   6
#define FILE_GIF  	   7
#define FILE_JPEG_LIST 8
#define FILE_AU        9
#define FILE_AIFF      10
#define FILE_SND       11
#define FILE_AVI       12
#define FILE_TGA_LIST  13
#define FILE_TGA       14
#define FILE_MPEG      15
#define FILE_PLUGIN    0x8000

// For formats supported by plugins, the format number is the plugin number in the 
// plugin list ORed with 0x8000.

#define AU_NAME "Sun/NeXT AU"
#define AIFF_NAME "Apple/SGI AIFF"
#define WAV_NAME "Microsoft WAV"
#define PCM_NAME "Raw PCM"
#define SND_NAME "Unknown sound"
#define PNG_NAME "PNG"
#define JPEG_NAME "JPEG"
#define TIFF_NAME "TIFF"
#define MPEG_NAME "MPEG"
#define MOV_NAME "Quicktime for Linux"
#define AVI_NAME "Microsoft AVI"
#define JPEG_LIST_NAME "JPEG List"
#define TGA_LIST_NAME "TGA List"
#define TGA_NAME "TGA"


#define BITSLINEAR8    8
#define BITSLINEAR16   16
#define BITSLINEAR24   24
#define BITSLINEAR32   32
#define BITS_ADPCM     252
#define BITSFLOAT      253
#define BITSULAW       254
#define BITSIMA4       255

// Video formats not part of Quicktime
#define MOV_RGBA "RGB ALPHA"
#define MOV_PNGA "PNG ALPHA"

class File;

#endif
