#include "autos.h"
#include "filexml.h"
#include "floatauto.h"

FloatAuto::FloatAuto(EDL *edl, FloatAutos *autos)
 : Auto(edl, (Autos*)autos)
{
	value = 0; 
}

FloatAuto::~FloatAuto()
{
}

float FloatAuto::value_to_percentage()
{
//printf("FloatAuto::value_to_percentage %f %f %f %f\n", value, autos->min, autos->max, (value - autos->min) / (autos->max - autos->min));
	return (value - autos->min) / (autos->max - autos->min) - 0.5;
}

void FloatAuto::copy_from(Auto *that)
{
	Auto::copy_from(that);
	this->value = ((FloatAuto*)that)->value;
}

int FloatAuto::value_to_str(char *string, float value)
{
	int j = 0, i = 0;
	if(value > 0) sprintf(string, "+%.2f", value);
	else sprintf(string, "%.2f", value);

// fix number
	if(value == 0)
	{
		j = 0;
		string[1] = 0;
	}
	else
	if(value < 1 && value > -1) 
	{
		j = 1;
		string[j] = string[0];
	}
	else 
	{
		j = 0;
		string[3] = 0;
	}
	
	while(string[j] != 0) string[i++] = string[j++];
	string[i] = 0;
}

void FloatAuto::copy(long start, long end, FileXML *file)
{
	file->tag.set_title("AUTO");
	file->tag.set_property("POSITION", position - start);
	file->tag.set_property("VALUE", value);
	file->append_tag();
}

void FloatAuto::load(FileXML *xml)
{
	position = xml->tag.get_property("POSITION", (long)0);
	value = xml->tag.get_property("VALUE", (float)0);
}
