#include "edl.h"
#include "edlsession.h"
#include "filexml.h"
#include "intauto.h"
#include "intautos.h"

IntAuto::IntAuto(EDL *edl, IntAutos *autos)
 : Auto(edl, (Autos*)autos)
{
	value = 0;
}

IntAuto::~IntAuto()
{
}

void IntAuto::load(FileXML *file)
{
	position = file->tag.get_property("POSITION", (long)0);
	value = file->tag.get_property("VALUE", value);
}

void IntAuto::copy(long start, long end, FileXML *file)
{
	file->tag.set_title("AUTO");
	file->tag.set_property("POSITION", position - start);
	file->tag.set_property("VALUE", value);
	file->append_tag();
}


void IntAuto::copy_from(Auto *that)
{
	Auto::copy_from(that);
	IntAuto *int_auto = (IntAuto*)that;
	this->value = int_auto->value;
}


