#include "filexml.h"
#include "keyframe.h"

#include <stdio.h>
#include <string.h>

KeyFrame::KeyFrame()
 : ListItem<KeyFrame>()
{
	data[0] = 0;
	position = 0;
}
KeyFrame::~KeyFrame()
{
}

KeyFrame& KeyFrame::operator=(KeyFrame &that)
{
//printf("KeyFrame::operator= %s\n%s\n", data, that.data);
	strcpy(data, that.data);
	position = that.position;
	return *this;
}

int KeyFrame::operator==(KeyFrame &that)
{
printf("KeyFrame::operator==\n");
	return !strcpy(that.data, data);
}


void KeyFrame::load(FileXML *file)
{
	position = file->tag.get_property("POSITION", position);
	strcpy(data, file->read_text());
}

void KeyFrame::save(long start, FileXML *file)
{
	file->tag.set_title("KEYFRAME");
	file->tag.set_property("POSITION", position - start);
	file->append_tag();
	file->append_newline();

	file->append_text(data);
	file->append_newline();

	file->tag.set_title("/KEYFRAME");
	file->append_tag();
	file->append_newline();
}

void KeyFrame::dump()
{
	printf("     position: %ld\n", position);
	printf("     data: %s\n", data);
}
