#ifndef KEYFRAMES_H
#define KEYFRAMES_H

#include "filexml.inc"
#include "keyframe.inc"
#include "linklist.h"

class KeyFrames : public List<KeyFrame>
{
public:
	KeyFrames();
	~KeyFrames();

	void create_objects();
	KeyFrame* insert_keyframe(long position);
	void copy(long start, long end, FileXML *file);
	void paste(FileXML *file);
	void optimize();
	void copy_from(KeyFrames *keyframes);
	void resample(double old_rate, double new_rate);

// Default settings if no keyframes.
// Having a persistent keyframe created problems when files were loaded and
// we wanted to keep only 1 keyframe
	KeyFrame *default_keyframe;
};

#endif
