#ifndef LEVELWINDOWGUI_H
#define LEVELWINDOWGUI_H

class LevelWindowReset;

#include "guicast.h"
#include "levelwindow.inc"
#include "maxchannels.h"
#include "mwindow.inc"

class LevelWindowGUI : public BC_Window
{
public:
	LevelWindowGUI(MWindow *mwindow, LevelWindow *thread, int w, int h);
	~LevelWindowGUI();

	int create_objects();
	int resize_event(int w, int h);
	int new_meter();
	int delete_meter();
	int close_event();
	int reset_over();
	int keypress_event();

	int total_meters;
	BC_Meter *meters[MAXCHANNELS];
	BC_Title *titles[MAXCHANNELS];
	LevelWindowReset *reset_button;
	MWindow *mwindow;

	LevelWindow *thread;
	int METER_H;
	int db_scale;
};

class LevelWindowReset : public BC_Button
{
public:
	LevelWindowReset(MWindow *mwindow, LevelWindowGUI *gui, int x, int y);
	~LevelWindowReset();
	int handle_event();

	LevelWindowGUI *gui;
};


#endif
