#include "edl.h"
#include "edlsession.h"
#include "deleteallindexes.h"
#include "mwindow.h"
#include "performanceprefs.h"
#include "preferences.h"
#include <string.h>

PerformancePrefs::PerformancePrefs(MWindow *mwindow, PreferencesWindow *pwindow)
 : PreferencesDialog(mwindow, pwindow)
{
}

PerformancePrefs::~PerformancePrefs()
{
	delete ipath;
	delete ipathtext;
	delete isize;
	delete csize;
	delete deleteall;
//	delete smp;
	delete icount;
}

int PerformancePrefs::create_objects()
{
	int x = 5, y = 5;
	char string[1024];

// 	add_border(get_resources()->get_bg_shadow1(),
// 		get_resources()->get_bg_shadow2(),
// 		get_resources()->get_bg_color(),
// 		get_resources()->get_bg_light2(),
// 		get_resources()->get_bg_light1());
	add_subwindow(new BC_Title(x, y, "Performance", LARGEFONT, BLACK));

	y += 35;
	add_subwindow(new BC_Title(x, y, "Index files go here:", MEDIUMFONT, BLACK));
	y += 20;
	add_subwindow(ipathtext = new IndexPathText(x, y, pwindow, pwindow->thread->preferences->index_directory));
	add_subwindow(ipath = new BrowseButton(mwindow,
		this,
		ipathtext, 
		x + 250, 
		y, 
		pwindow->thread->preferences->index_directory,
		"Index Path", 
		"Select the directory for index files",
		1));

	y += 30;
	add_subwindow(new BC_Title(x, y + 5, "Size of index file:", MEDIUMFONT, BLACK));
	sprintf(string, "%ld", pwindow->thread->preferences->index_size);
	add_subwindow(isize = new IndexSize(240, y, pwindow, string));
	y += 30;
	add_subwindow(new BC_Title(x, y + 5, "Number of index files to keep:", MEDIUMFONT, BLACK));
	sprintf(string, "%ld", pwindow->thread->preferences->index_count);
	add_subwindow(icount = new IndexCount(240, y, pwindow, string));
	add_subwindow(deleteall = new DeleteAllIndexes(mwindow, pwindow, 350, y));
	y += 30;
	add_subwindow(new BC_Title(x, y + 5, "Cache items:", MEDIUMFONT, BLACK));
	sprintf(string, "%ld", pwindow->thread->edl->session->cache_size);
	add_subwindow(csize = new CacheSize(240, y, pwindow, string));
	y += 30;
// 	add_subwindow(new BC_Title(x, y + 5, "Number of CPUs to use:"));
// 	add_subwindow(smp = new PrefsSMP(240, y, pwindow));
	return 0;
}






IndexPathText::IndexPathText(int x, int y, PreferencesWindow *pwindow, char *text)
 : BC_TextBox(x, y, 240, 1, text)
{
	this->pwindow = pwindow; 
}

IndexPathText::~IndexPathText() {}

int IndexPathText::handle_event()
{
	strcpy(pwindow->thread->preferences->index_directory, get_text());
}




IndexSize::IndexSize(int x, int y, PreferencesWindow *pwindow, char *text)
 : BC_TextBox(x, y, 100, 1, text)
{ 
	this->pwindow = pwindow; 
}

int IndexSize::handle_event()
{
	long result;

	result = atol(get_text());
	if(result < 64000) result = 64000;
	//if(result < 500000) result = 500000;
	pwindow->thread->preferences->index_size = result;
	return 0;
}



IndexCount::IndexCount(int x, int y, PreferencesWindow *pwindow, char *text)
 : BC_TextBox(x, y, 100, 1, text)
{ 
	this->pwindow = pwindow; 
}

int IndexCount::handle_event()
{
	long result;

	result = atol(get_text());
	if(result < 1) result = 1;
	pwindow->thread->preferences->index_count = result;
	return 0;
}



PrefsSMP::PrefsSMP(int x, int y, PreferencesWindow *pwindow)
 : BC_TextBox(x, y, 100, 1, pwindow->thread->edl->session->smp + 1)
{ 
	this->pwindow = pwindow; 
}

PrefsSMP::~PrefsSMP()
{
}

int PrefsSMP::handle_event()
{
	pwindow->thread->edl->session->smp = atol(get_text()) - 1;
	if(pwindow->thread->edl->session->smp < 0) pwindow->thread->edl->session->smp = 0;
	return 0;
}


CacheSize::CacheSize(int x, int y, PreferencesWindow *pwindow, char *text)
 : BC_TextBox(x, y, 100, 1, text)
{ 
	this->pwindow = pwindow; 
}

int CacheSize::handle_event()
{
	long result;

	result = atol(get_text());
	pwindow->thread->edl->session->cache_size = result;
	return 0;
}

