#ifndef PERFORMANCEPREFS_H
#define PERFORMANCEPREFS_H

class IndexSize;
class IndexCount;
class IndexPathText;
class CacheSize;
class PrefsSMP;

#include "browsebutton.h"
#include "deleteallindexes.inc"
#include "mwindow.inc"
#include "preferencesthread.h"

class PerformancePrefs : public PreferencesDialog
{
public:
	PerformancePrefs(MWindow *mwindow, PreferencesWindow *pwindow);
	~PerformancePrefs();
	
	int create_objects();
// must delete each derived class
	BrowseButton *ipath;
	IndexSize *isize;
	IndexCount *icount;
	IndexPathText *ipathtext;
	CacheSize *csize;
	DeleteAllIndexes *deleteall;
	PrefsSMP *smp;
};







class PrefsSMP : public BC_TextBox
{
public:
	PrefsSMP(int x, int y, PreferencesWindow *pwindow);
	~PrefsSMP();

	int handle_event();
	PreferencesWindow *pwindow;
};


class IndexPathText : public BC_TextBox
{
public:
	IndexPathText(int x, int y, PreferencesWindow *pwindow, char *text);
	~IndexPathText();
	int handle_event();
	PreferencesWindow *pwindow;
};

class CacheSize : public BC_TextBox
{
public:
	CacheSize(int x, int y, PreferencesWindow *pwindow, char *text);
	int handle_event();
	PreferencesWindow *pwindow;
};



class IndexSize : public BC_TextBox
{
public:
	IndexSize(int x, int y, PreferencesWindow *pwindow, char *text);
	int handle_event();
	PreferencesWindow *pwindow;
};


class IndexCount : public BC_TextBox
{
public:
	IndexCount(int x, int y, PreferencesWindow *pwindow, char *text);
	int handle_event();
	PreferencesWindow *pwindow;
};


#endif
