#include "audioconfig.h"
#include "audiodevice.inc"
#include "bcmeter.inc"
#include "defaults.h"
#include "defaulttheme.h"
#include "filesystem.h"
#include "guicast.h"
#include "mwindow.h"
#include "preferences.h"
#include "theme.h"
#include "videoconfig.h"
#include "videodevice.inc"
#include <string.h>

#define CLAMP(x, y, z) (x) = ((x) < (y) ? (y) : ((x) > (z) ? (z) : (x)))












Preferences::Preferences(MWindow *mwindow)
{
// Set defaults
	FileSystem fs;
	
	this->mwindow = mwindow;
	sprintf(index_directory, BCASTDIR);
	if(strlen(index_directory))
		fs.complete_path(index_directory);
	index_size = 1000000;
	index_count = 100;
	theme[0] = 0;
}

Preferences::~Preferences()
{
}

Preferences& Preferences::operator=(Preferences &that)
{
// ================================= Performance ================================
	this->mwindow = that.mwindow;
	strcpy(index_directory, that.index_directory);
	index_size = that.index_size;
	index_count = that.index_count;
	strcpy(global_plugin_dir, that.global_plugin_dir);
	strcpy(local_plugin_dir, that.local_plugin_dir);
	strcpy(theme, that.theme);

// Check boundaries

	FileSystem fs;
	if(strlen(index_directory))
	{
		fs.complete_path(index_directory);
		fs.add_end_slash(index_directory);
	}
	
	if(strlen(global_plugin_dir))
	{
		fs.complete_path(global_plugin_dir);
		fs.add_end_slash(global_plugin_dir);
	}
	
	if(strlen(local_plugin_dir))
	{
		fs.complete_path(local_plugin_dir);
		fs.add_end_slash(local_plugin_dir);
	}
	return *this;
}

int Preferences::load_defaults(Defaults *defaults)
{
	char string[BCTEXTLEN];

	defaults->get("INDEX_DIRECTORY", index_directory);
	index_size = defaults->get("INDEX_SIZE", index_size);
	index_count = defaults->get("INDEX_COUNT", index_count);

	sprintf(global_plugin_dir, "/usr/local/bcast/plugins");
	sprintf(local_plugin_dir, "");
	strcpy(theme, DefaultTheme::default_theme_title);
	defaults->get("GLOBAL_PLUGIN_DIR", global_plugin_dir);
	defaults->get("LOCAL_PLUGIN_DIR", local_plugin_dir);
	defaults->get("THEME", theme);

	return 0;
}

int Preferences::save_defaults(Defaults *defaults)
{
	defaults->update("INDEX_DIRECTORY", index_directory);
	defaults->update("INDEX_SIZE", index_size);
	defaults->update("INDEX_COUNT", index_count);
	defaults->update("GLOBAL_PLUGIN_DIR", global_plugin_dir);
	defaults->update("LOCAL_PLUGIN_DIR", local_plugin_dir);
	defaults->update("THEME", theme);
	return 0;
}
