#ifndef PREFERENCES_H
#define PREFERENCES_H

#include "audioconfig.inc"
#include "defaults.inc"
#include "guicast.h"
#include "maxchannels.h"
#include "mwindow.h"
#include "preferences.inc"
#include "videoconfig.inc"


class Preferences
{
public:
	Preferences(MWindow *mwindow);
	~Preferences();

	Preferences& operator=(Preferences &that);
	int load_defaults(Defaults *defaults);
	int save_defaults(Defaults *defaults);

// ================================= Performance ================================
// directory to look in for indexes
	char index_directory[BCTEXTLEN];   
// size of index file in bytes
	long index_size;                  
	int index_count;
// Title of theme
	char theme[BCTEXTLEN];


// ====================================== PluginSet ==============================
	char global_plugin_dir[BCTEXTLEN];
	char local_plugin_dir[BCTEXTLEN];
	
	
	MWindow *mwindow;
};

#endif
