#include "formattools.h"
//#include "loadmode.h"
#include "mwindow.h"
#include "mwindowgui.h"
#include "record.h"
#include "recordwindow.h"
#include "videodevice.inc"

#define WIDTH 410
#define HEIGHT 360


RecordWindow::RecordWindow(MWindow *mwindow, Record *record)
 : BC_Window(PROGRAM_NAME ": Record", 
 	mwindow->gui->get_root_w() / 2 - WIDTH / 2,
	mwindow->gui->get_root_h() / 2 - HEIGHT / 2,
 	WIDTH, 
	HEIGHT,
	(int)INFINITY,
	(int)INFINITY,
	0,
	0,
	1)
{
	this->mwindow = mwindow;
	this->record = record;
}

RecordWindow::~RecordWindow()
{
	delete format_tools;
//	delete loadmode;
}



int RecordWindow::create_objects()
{
	add_subwindow(new BC_Title(5, 5, "Select a file to record to:"));

	int x = 5, y = 25;
	format_tools = new FormatTools(mwindow,
					this, 
					record->default_asset);
	format_tools->create_objects(x, 
					y, 
					1, 
					1, 
					1, 
					1, 
					1, 
					1,
					record->fixed_compression,
					0,
					1,
					0);

	x = 10;
// 	loadmode = new LoadMode(this, x, y, &record->load_mode);
// 	loadmode->create_objects();

	add_subwindow(new BC_OKButton(this));
	add_subwindow(new BC_CancelButton(this));
	show_window();
	return 0;
}







RecordToTracks::RecordToTracks(Record *record, int default_)
 : BC_CheckBox(200, 270, default_) { this->record = record; }
RecordToTracks::~RecordToTracks() 
{}
int RecordToTracks::handle_event()
{
	record->to_tracks = get_value();
}

