#include "edl.h"
#include "edlsession.h"
#include "samplescroll.h"
#include "mwindow.h"
#include "mwindowgui.h"
#include "patchbay.h"
#include "mainsession.h"
#include "theme.h"
#include "timebar.h"
#include "trackcanvas.h"
#include "tracks.h"

SampleScroll::SampleScroll(MWindow *mwindow, MWindowGUI *gui, int pixels)
 : BC_ScrollBar(mwindow->theme->mcanvas_x, 
 	mwindow->theme->mcanvas_y + mwindow->theme->mcanvas_h - SCROLL_SPAN,
	SCROLL_HORIZ, 
	pixels, 
	0, 
	0, 
	0)
{
	this->gui = gui;
	this->mwindow = mwindow;
	oldposition = 0;
}

SampleScroll::~SampleScroll()
{
}

int SampleScroll::flip_vertical()
{
	return 0;
}

int SampleScroll::in_use()
{
	return in_use();
}


int SampleScroll::resize_event()
{
	reposition_window(mwindow->theme->mcanvas_x,
		mwindow->theme->mcanvas_y + mwindow->theme->mcanvas_h - SCROLL_SPAN, 
		mwindow->theme->mcanvas_w - SCROLL_SPAN);
	return 0;
}

int SampleScroll::set_position()
{
	if(!gui->canvas) return 0;
	long length = (long)(mwindow->edl->tracks->total_length() * 
		mwindow->edl->session->sample_rate + 
		0.5);
	long position = (long)(mwindow->edl->session->view_start * 
		mwindow->edl->session->sample_rate + 
		0.5);
	long handle_size = gui->canvas->get_w() * 
		mwindow->edl->session->zoom_sample;

	update_length(length, 
			position, 
			handle_size);

	oldposition = position;
	return 0;
}

int SampleScroll::handle_event()
{
//printf("SampleScroll::handle_event 1 %d %d\n", mwindow->edl->session->sample_rate, get_value());
	mwindow->edl->session->view_start = (double)get_value() / 
		mwindow->edl->session->sample_rate;


//printf("SampleScroll::handle_event 1 %f\n", mwindow->edl->session->view_start);
	mwindow->gui->canvas->draw();
	mwindow->gui->cursor->draw();
//printf("SampleScroll::handle_event 1\n");
	mwindow->gui->canvas->flash();
//printf("SampleScroll::handle_event 1\n");
	mwindow->gui->patchbay->update();
//printf("SampleScroll::handle_event 1\n");
	mwindow->gui->timebar->update();
//printf("SampleScroll::handle_event 1\n");
// Scrollbar must be active to trap button release events
//	mwindow->gui->canvas->activate();
//printf("SampleScroll::handle_event 2\n");
	return 1;
}
