#ifndef SETAUDIO_H
#define SETAUDIO_H

#include "edl.inc"
#include "guicast.h"
#include "mwindow.inc"
#include "rotateframe.inc"
#include "vframe.inc"

class SetAudioThread;
class SetAudioWindow;

class SetAudio : public BC_MenuItem
{
public:
	SetAudio(MWindow *mwindow);
	~SetAudio();
	
	int handle_event();
	MWindow *mwindow;
	SetAudioThread *thread;
};


class SetAudioThread : public Thread
{
public:
	SetAudioThread(MWindow *mwindow);
	~SetAudioThread();

	void run();

	MWindow *mwindow;
	SetAudioWindow *window;
	EDL *new_settings;
};

class SetChannelsCanvas;

class SetAudioWindow : public BC_Window
{
public:
	SetAudioWindow(MWindow *mwindow, SetAudioThread *thread);
	~SetAudioWindow();

	int create_objects();
	
	MWindow *mwindow;
	SetAudioThread *thread;
	SetChannelsCanvas *canvas;
};

class SetSampleRateTextBox : public BC_TextBox
{
public:
	SetSampleRateTextBox(SetAudioThread *thread, int x, int y);
	int handle_event();
	SetAudioThread *thread;
};

class SetChannelsTextBox : public BC_TextBox
{
public:
	SetChannelsTextBox(SetAudioThread *thread, int x, int y);
	
	int handle_event();
	
	SetAudioThread *thread;
	MWindow *mwindow;
};


class SetChannelsCanvas : public BC_SubWindow
{
public:
	SetChannelsCanvas(MWindow *mwindow, SetAudioThread *thread, int x, int y);
	~SetChannelsCanvas();
	
	int draw(int angle = -1);
	int get_dimensions(int channel_position, int &x, int &y, int &w, int &h);
	int button_press_event();
	int button_release_event();
	int cursor_motion_event();

private:	
	int active_channel;   // for selection
	int degree_offset;
	int box_r;
	
	int poltoxy(int &x, int &y, int r, int d);
	int xytopol(int &d, int x, int y);
	MWindow *mwindow;
	SetAudioThread *thread;
	VFrame *temp_picon;
	RotateFrame *rotater;
};

#endif
