#include "mainprogress.h"
#include "mwindow.h"
#include "statusbar.h"
#include "theme.h"

StatusBar::StatusBar(MWindow *mwindow, MWindowGUI *gui)
 : BC_SubWindow(mwindow->theme->mstatus_x, 
 	mwindow->theme->mstatus_y, 
	mwindow->theme->mstatus_w, 
	mwindow->theme->mstatus_h)
{
	this->mwindow = mwindow;
	this->gui = gui;
}

StatusBar::~StatusBar()
{
}



int StatusBar::create_objects()
{
//printf("StatusBar::create_objects 1\n");
	mwindow->theme->draw_mstatus_bg(this);
	int x = 10, y = 1;
//printf("StatusBar::create_objects 1\n");
	add_subwindow(status_text = new BC_Title(x, y, ""));
	x = get_w() - 290;
//printf("StatusBar::create_objects 1\n");
	add_subwindow(main_progress = new BC_ProgressBar(x, y, 200, 200));
	x += main_progress->get_w() + 5;
//printf("StatusBar::create_objects 1\n");
	add_subwindow(main_progress_cancel = new StatusBarCancel(mwindow, x, y));
//printf("StatusBar::create_objects 1\n");
	default_message();
	flash();
//printf("StatusBar::create_objects 2\n");
	return 0;
}

void StatusBar::resize_event()
{
	reposition_window(mwindow->theme->mstatus_x,
		mwindow->theme->mstatus_y,
		mwindow->theme->mstatus_w,
		mwindow->theme->mstatus_h);
	int x = 10, y = 1;
	status_text->reposition_window(x, y);
	x = get_w() - 290;
	main_progress->reposition_window(x, y);
	x += main_progress->get_w() + 5;
	main_progress_cancel->reposition_window(x, y);
}

void StatusBar::set_message(char *text)
{
	status_text->update(text);
}

void StatusBar::default_message()
{
	status_text->update("Welcome to Cinelerra.");
}


StatusBarCancel::StatusBarCancel(MWindow *mwindow, int x, int y)
 : BC_Button(x, y, mwindow->theme->statusbar_cancel_data)
{
	this->mwindow = mwindow;
}
int StatusBarCancel::handle_event()
{
	mwindow->mainprogress->cancelled = 1;
	return 1;
}
