#include "autoconf.h"
#include "edl.h"
#include "edlsession.h"
#include "mainmenu.h"
#include "mwindow.h"
#include "mwindowgui.h"
#include "viewmenu.h"
#include "trackcanvas.h"


ShowEdits::ShowEdits(MWindow *mwindow, char *hotkey)
 : BC_MenuItem("Show edits", hotkey, hotkey[0])
{ 
	this->mwindow = mwindow; 
	set_checked(0); 
}
int ShowEdits::handle_event()
{
//	mwindow->tracks->toggle_handles();
	set_checked(get_checked() ^ 1);
	return 1;
}

ShowTitles::ShowTitles(MWindow *mwindow, char *hotkey)
 : BC_MenuItem("Show titles", hotkey, hotkey[0])
{
	this->mwindow = mwindow; 
	set_checked(mwindow->edl->session->show_titles); 
}
int ShowTitles::handle_event()
{
	set_checked(get_checked() ^ 1);
	mwindow->edl->session->show_titles = get_checked();
	mwindow->gui->update(1,
		1,
		0,
		0,
		1, 
		0);
	return 1;
}


ShowKeyframes::ShowKeyframes(MWindow *mwindow, char *hotkey)
 : BC_MenuItem("Plugin keyframes", hotkey, hotkey[0])
{ 
	this->mwindow = mwindow; 
//	set_checked(mwindow->edl->session->auto_conf->keyframes); 
}
int ShowKeyframes::handle_event()
{
	return 1;
}


ShowTransitions::ShowTransitions(MWindow *mwindow, char *hotkey)
 : BC_MenuItem("Show transitions", hotkey, hotkey[0])
{ 
	this->mwindow = mwindow; 
	set_checked(mwindow->edl->session->auto_conf->transitions); 
}
int ShowTransitions::handle_event()
{
	set_checked(get_checked() ^ 1);
	mwindow->edl->session->auto_conf->transitions = get_checked();
	mwindow->gui->canvas->draw_overlays();
	mwindow->gui->canvas->flash();
	return 1;
}


FadeAutomation::FadeAutomation(MWindow *mwindow, char *hotkey)
 : BC_MenuItem("Fade keyframes", hotkey, hotkey[0])
{ 
	this->mwindow = mwindow; 
	set_checked(mwindow->edl->session->auto_conf->fade); 
} 
int FadeAutomation::handle_event()
{
	set_checked(get_checked() ^ 1);
	mwindow->edl->session->auto_conf->fade = get_checked();
	mwindow->gui->canvas->draw_overlays();
	mwindow->gui->canvas->flash();
	return 1;
}

PlayAutomation::PlayAutomation(MWindow *mwindow, char *hotkey)
 : BC_MenuItem("Play keyframes", hotkey, hotkey[0])
{ 
	this->mwindow = mwindow; 
	set_checked(mwindow->edl->session->auto_conf->play); 
} 
int PlayAutomation::handle_event()
{ 
	set_checked(get_checked() ^ 1);
	mwindow->edl->session->auto_conf->play = get_checked();
	mwindow->gui->canvas->draw_overlays();
	mwindow->gui->canvas->flash();
	return 1;
}


CameraAutomation::CameraAutomation(MWindow *mwindow, char *hotkey)
 : BC_MenuItem("Camera keyframes", hotkey, hotkey[0]) 
{ 
	this->mwindow = mwindow; 
	set_checked(0); 
} 
int CameraAutomation::handle_event()
{ 
	set_checked(get_checked() ^ 1);
	mwindow->edl->session->auto_conf->camera = get_checked();
	mwindow->gui->canvas->draw_overlays();
	mwindow->gui->canvas->flash();
	return 1;
}


ProjectAutomation::ProjectAutomation(MWindow *mwindow, char *hotkey)
 : BC_MenuItem("Projector keyframes", hotkey, hotkey[0]) 
{ 
	this->mwindow = mwindow; 
	set_checked(0); 
}
int ProjectAutomation::handle_event()
{
	set_checked(get_checked() ^ 1);
	mwindow->edl->session->auto_conf->projector = get_checked();
	mwindow->gui->canvas->draw_overlays();
	mwindow->gui->canvas->flash();
	return 1;
}


ShowRenderedOutput::ShowRenderedOutput(MWindow *mwindow, char *hotkey)
 : BC_MenuItem("Draw Output", hotkey, hotkey[0])
{ 
	this->mwindow = mwindow; 
	set_checked(0); 
}
int ShowRenderedOutput::handle_event()
{
//	mwindow->tracks->set_draw_output();
//	if(mwindow->tracks->show_output) set_text("Draw Tracks"); else set_text("Draw Output");
	return 1;
}


MuteAutomation::MuteAutomation(MWindow *mwindow, char *hotkey)
 : BC_MenuItem("Mute keyframes", hotkey, hotkey[0])
{ 
	this->mwindow = mwindow; 
	set_checked(mwindow->edl->session->auto_conf->mute); 
}
int MuteAutomation::handle_event()
{
	set_checked(get_checked() ^ 1);
	mwindow->edl->session->auto_conf->mute = get_checked();
	mwindow->gui->canvas->draw_overlays();
	mwindow->gui->canvas->flash();
	return 1;
}


PanAutomation::PanAutomation(MWindow *mwindow, char *hotkey)
 : BC_MenuItem("Pan keyframes", hotkey, hotkey[0]) 
{ 
	this->mwindow = mwindow; 
	set_checked(mwindow->edl->session->auto_conf->pan); 
}
int PanAutomation::handle_event()
{
	set_checked(get_checked() ^ 1);
	mwindow->edl->session->auto_conf->pan = get_checked();
	mwindow->gui->canvas->draw_overlays();
	mwindow->gui->canvas->flash();
	return 1;
}

PluginAutomation::PluginAutomation(MWindow *mwindow, char *hotkey)
 : BC_MenuItem("Plugin keyframes", hotkey, hotkey[0]) 
{ 
	this->mwindow = mwindow; 
}

int PluginAutomation::handle_event()
{
	set_checked(!get_checked());
	mwindow->edl->session->auto_conf->plugins = get_checked();
	mwindow->gui->canvas->draw_overlays();
	mwindow->gui->canvas->flash();
	return 1;
}

ModeAutomation::ModeAutomation(MWindow *mwindow, char *hotkey)
 : BC_MenuItem("Mode keyframes", hotkey, hotkey[0]) 
{ 
	this->mwindow = mwindow;
}

int ModeAutomation::handle_event()
{
	set_checked(!get_checked());
	mwindow->edl->session->auto_conf->mode = get_checked();
	mwindow->gui->canvas->draw_overlays();
	mwindow->gui->canvas->flash();
	return 1;
}
