#include "defaults.h"
#include "mainwindow.h"
#include "images/logo_png.h"

int main(int argc, char *argv[])
{
	MainWindow window;
	window.initialize();
	return 0;
}


MainWindow::MainWindow()
{
}


MainWindow::~MainWindow()
{
	delete gui;
	delete defaults;
}

int MainWindow::initialize()
{
	defaults = new Defaults("~/.heroine_encode_rc");
	gui = new MainGUI(this);
	gui->initialize();
	gui->run_window();
}


MainGUI::MainGUI(MainWindow *mwindow)
 : BC_Window("Heroine Encoder", 
 		mwindow->defaults->get("WIDTH", 640),
		mwindow->defaults->get("HEIGHT", 640),
		10,
		10,
		0,
		0)
{
	this->mwindow = mwindow;
}

MainGUI::~MainGUI()
{
}

int MainGUI::initialize()
{
	int x = 10, y = 0, w, h;
	int margins = 40;
	BC_Bitmap bitmap(this, logo_png, sizeof(logo_png), get_bgcolor());

	add_subwindow(logo = new BC_SubWindow(x, y, bitmap.get_w(), bitmap.get_h(), get_bgcolor()));
	logo->draw_bitmap(&bitmap, 0);
	logo->flash();

	x = 0;
	y += logo->get_h() + 5;
	w = (get_w() - margins) / 2;
	h = get_h() - 400;
	draw_colored_box(x + margins / 4 - 2, y - 2, w + 4, h + 4, 1, 0);
	add_subwindow(input_canvas = new BC_SubWindow(x + margins / 4, y, w, h, BLACK));

	x += get_w() / 2;
	draw_colored_box(x + margins / 4 - 2, y - 2, w + 4, h + 4, 1, 0);
	add_subwindow(input_canvas = new BC_SubWindow(x + margins / 4, y, w, h, BLACK));

	x = 10;
	y += input_canvas->get_h() + 20;
	draw_border("Video", x, y, 240, 200);

	flash();
	return 0;
}





