#include "assets.h"
#include "audiodevice.h"
#include "montevideo.h"
#include "mvaudioout.h"

MVAudioOut::MVAudioOut(MonteVideo *montevideo)
 : Thread()
{
	set_synchronous(1);
	this->montevideo = montevideo;
	done = 0;
	for(int i = 0; i < montevideo->asset->channels; i++)
	{
		buffer[i] = new float[AUDIOBUFFER];
	}
	current_sample = 0;
}

MVAudioOut::~MVAudioOut()
{
	for(int i = 0; i < montevideo->asset->channels; i++)
	{
		delete [] buffer[i];
	}
}

long MVAudioOut::get_sync_position()
{
	return montevideo->audio_out->current_position();
}

void MVAudioOut::run()
{
	while(!done)
	{
//printf("MVAudioOut::run 1 %d\n", current_sample);
		int result = montevideo->read_audio(buffer, AUDIOBUFFER, current_sample);
		
//printf("MVAudioOut::run 1\n");
		if(!result)
			montevideo->audio_out->write_buffer(buffer, AUDIOBUFFER);
		
//printf("MVAudioOut::run 2\n");
		current_sample += AUDIOBUFFER;
	}
}
