#include "keys.h"
#include "montevideo.h"
#include "mvconsole.h"
#include "mvinterface.h"

#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <unistd.h>
#include <termios.h>

MVConsole::MVConsole(MonteVideo *montevideo)
{
	this->montevideo = montevideo;
	done = 0;
}

MVConsole::~MVConsole()
{
}

int MVConsole::get_character()
{
    char c;
    struct termio savetty, settty;

	ioctl(0, TCGETA, &savetty);
	settty = savetty;
	settty.c_lflag &= ~ICANON;
	settty.c_lflag &= ~ECHO;
	ioctl(0, TCSETAF, &settty);
    c = getchar();
    ioctl(0, TCSETAF, &savetty);
    return c;
}


int MVConsole::translate_keypress(int keypress)
{
	switch(keypress)
	{
// 		case KEY_UP:
// 			return UP;
// 			break;
// 		case KEY_DOWN:
// 			return DOWN;
// 			break;
// 		case KEY_LEFT:
// 			return LEFT;
// 			break;
// 		case KEY_RIGHT:
// 			return RIGHT;
// 			break;
// 		case 27: /* ESC */
// 			return ESC;
// 			break;
// 		case KEY_NPAGE:
// 			return PGDN;
// 			break;
// 		case KEY_PPAGE:
// 			return PGUP;
// 			break;
 	}
	return keypress;
}

void MVConsole::run_window()
{
	while(!done)
	{
		int keypress = get_character();
		keypress = translate_keypress(keypress);
		montevideo->interface->keypress_event(keypress);
	}
}



