#include "keys.h"
#include "montevideo.h"
#include "mvconsole.h"
#include "mvinterface.h"
#include "mvwindow.h"
#include "vframe.h"

#include <string.h>

MVMenu::MVMenu(MonteVideo *montevideo)
{
	this->montevideo = montevideo;
}

MVMenu::~MVMenu()
{
}

int MVMenu::keypress_event(int keypress)
{
	return 0;
}




MVInterface::MVInterface(MonteVideo *montevideo)
 : Thread()
{
	this->montevideo = montevideo;
	menu = new MVMenu(montevideo);
	print_console();
}

MVInterface::~MVInterface()
{
	delete menu;
}

void MVInterface::print_console()
{
	printf(
"\n\nMontevideo keys:\n"
"\n"
"q                       Quit\n"
"Page Up                 Prev channel\n"
"Page Dn                 Next channel\n"
"+                       Increase loop buffer\n"
"-                       Decrease loop buffer\n"
"f                       Swap fields\n"
"d                       Deinterlace\n"
"\n"
	);
}

void MVInterface::run()
{
	if(montevideo->window)
		montevideo->window->run_window();
	else
		montevideo->console->run_window();
}

int MVInterface::keypress_event(int keypress)
{
printf("MVInterface::keypress_event 1\n");
	if(menu->keypress_event(keypress)) return 1;
printf("MVInterface::keypress_event 1\n");

	switch(keypress)
	{
		case 'q':
		case 'Q':
		case ESC:
			if(montevideo->window)
				montevideo->window->set_done(0);
			else
				montevideo->console->done = 1;
			montevideo->stop_all();
			return 1;
			break;
		case PGUP:
			montevideo->next_channel();
			return 1;
			break;
		case PGDN:
			montevideo->prev_channel();
			return 1;
			break;
		case 'f':
		case 'F':
			montevideo->field_order = !montevideo->field_order;
			return 1;
			break;
		case 'd':
			montevideo->deinterlace = !montevideo->deinterlace;
			break;
	}
printf("MVInterface::keypress_event 1\n");
	return 0;
}


void MVInterface::show_channel()
{
	bzero(montevideo->overlay->get_data(), 
		montevideo->overlay->get_data_size());
}



