#include "bcdisplayinfo.h"
#include "burnwindow.h"


BurnThread::BurnThread(BurnMain *client)
 : Thread()
{
	this->client = client;
	set_synchronous(0);
	gui_started.lock();
	completion.lock();
}

BurnThread::~BurnThread()
{
// Window always deleted here
	delete window;
}
	
void BurnThread::run()
{
	BC_DisplayInfo info;
	window = new BurnWindow(client, 
		info.get_abs_cursor_x() - 105, 
		info.get_abs_cursor_y() - 100);
	window->create_objects();
	gui_started.unlock();
	int result = window->run_window();
	completion.unlock();
// Last command executed in thread
	if(result) client->client_side_close();
}






BurnWindow::BurnWindow(BurnMain *client, int x, int y)
 : BC_Window(client->gui_string, 
	x,
	y,
	300, 
	170, 
	300, 
	170, 
	0, 
	0,
	1)
{ 
	this->client = client; 
}

BurnWindow::~BurnWindow()
{
}

int BurnWindow::create_objects()
{
	int x = 10, y = 10;
	add_subwindow(new BC_Title(x, y, 
		"BurningTV from EffectTV\n"
		"Copyright (C) 2001 FUKUCHI Kentarou"
	));

	show_window();
	flush();
	return 0;
}

int BurnWindow::close_event()
{
// Set result to 1 to indicate a client side close
	set_done(1);
	return 1;
}


