#include "crossfade.h"
#include "edl.inc"
#include "overlayframe.h"
#include "picon_png.h"
#include "vframe.h"

PluginClient* new_plugin(PluginServer *server)
{
	return new CrossfadeMain(server);
}





CrossfadeMain::CrossfadeMain(PluginServer *server)
 : PluginVClient(server)
{
}

CrossfadeMain::~CrossfadeMain()
{
}

char* CrossfadeMain::plugin_title() { return "Crossfade"; }
int CrossfadeMain::is_video() { return 1; }
int CrossfadeMain::is_transition() { return 1; }
int CrossfadeMain::uses_gui() { return 0; }

VFrame* CrossfadeMain::new_picon()
{
	return new VFrame(picon_png);
}


int CrossfadeMain::start_realtime()
{
	return 0;
}

int CrossfadeMain::stop_realtime()
{
	return 0;
}

int CrossfadeMain::process_realtime(VFrame *input_ptr, VFrame *output_ptr)
{
	OverlayFrame overlay;
	overlay.overlay(output_ptr, 
		input_ptr, 
		0, 
		0, 
		input_ptr->get_w(), 
		input_ptr->get_h(), 
		0, 
		0, 
		output_ptr->get_w(), 
		output_ptr->get_h(), 
		1 - (float)source_position / total_len, 
		TRANSFER_NORMAL,
		NEAREST_NEIGHBOR);
	
//printf("CrossfadeMain::process_realtime 1 %ld %ld\n", source_position, total_len);
	return 0;
}
