#ifndef CROSSFADEWINDOW_H
#define CROSSFADEWINDOW_H


class CrossfadeThread;
class CrossfadeWindow;

#include "crossfade.inc"
#include "filexml.inc"
#include "guicast.h"
#include "mutex.h"
#include "thread.h"

class CrossfadeThread : public Thread
{
public:
	CrossfadeThread(CrossfadeMain *client);
	~CrossfadeThread();

	void run();

	Mutex gui_started; // prevent loading data until the GUI is started
	CrossfadeMain *client;
	CrossfadeWindow *window;
};

class CrossfadeVertical;
class CrossfadeHorizontal;
class CrossfadeRadius;

class CrossfadeWindow : public BC_Window
{
public:
	CrossfadeWindow(CrossfadeMain *client, int x, int y);
	~CrossfadeWindow();
	
	int create_objects();
	int close_event();
	
	CrossfadeMain *client;
	CrossfadeVertical *vertical;
	CrossfadeHorizontal *horizontal;
	CrossfadeRadius *radius;
};

class CrossfadeRadius : public BC_IPot
{
public:
	CrossfadeRadius(CrossfadeMain *client, int x, int y);
	~CrossfadeRadius();
	int handle_event();

	CrossfadeMain *client;
};

class CrossfadeVertical : public BC_CheckBox
{
public:
	CrossfadeVertical(CrossfadeMain *client, CrossfadeWindow *window, int x, int y);
	~CrossfadeVertical();
	int handle_event();

	CrossfadeMain *client;
	CrossfadeWindow *window;
};

class CrossfadeHorizontal : public BC_CheckBox
{
public:
	CrossfadeHorizontal(CrossfadeMain *client, CrossfadeWindow *window, int x, int y);
	~CrossfadeHorizontal();
	int handle_event();

	CrossfadeMain *client;
	CrossfadeWindow *window;
};


#endif
