#include "dissolve.h"
#include "edl.inc"
#include "overlayframe.h"
#include "picon_png.h"
#include "vframe.h"

PluginClient* new_plugin(PluginServer *server)
{
	return new DissolveMain(server);
}





DissolveMain::DissolveMain(PluginServer *server)
 : PluginVClient(server)
{
}

DissolveMain::~DissolveMain()
{
}

char* DissolveMain::plugin_title() { return "Dissolve"; }
int DissolveMain::is_video() { return 1; }
int DissolveMain::is_transition() { return 1; }
int DissolveMain::uses_gui() { return 0; }

VFrame* DissolveMain::new_picon()
{
	return new VFrame(picon_png);
}


int DissolveMain::start_realtime()
{
	return 0;
}

int DissolveMain::stop_realtime()
{
	return 0;
}

int DissolveMain::process_realtime(VFrame *input_ptr, VFrame *output_ptr)
{
	OverlayFrame overlay;
	overlay.overlay(output_ptr, 
		input_ptr, 
		0, 
		0, 
		input_ptr->get_w(), 
		input_ptr->get_h(), 
		0, 
		0, 
		output_ptr->get_w(), 
		output_ptr->get_h(), 
		1 - (float)source_position / total_len, 
		TRANSFER_NORMAL,
		NEAREST_NEIGHBOR);
	
//printf("DissolveMain::process_realtime 1 %ld %ld\n", source_position, total_len);
	return 0;
}
