#ifndef BLURWINDOW_H
#define BLURWINDOW_H


class DissolveThread;
class DissolveWindow;

#include "dissolve.inc"
#include "filexml.inc"
#include "guicast.h"
#include "mutex.h"
#include "thread.h"

class DissolveThread : public Thread
{
public:
	DissolveThread(DissolveMain *client);
	~DissolveThread();

	void run();

	Mutex gui_started; // prevent loading data until the GUI is started
	DissolveMain *client;
	DissolveWindow *window;
};

class DissolveVertical;
class DissolveHorizontal;
class DissolveRadius;

class DissolveWindow : public BC_Window
{
public:
	DissolveWindow(DissolveMain *client, int x, int y);
	~DissolveWindow();
	
	int create_objects();
	int close_event();
	
	DissolveMain *client;
	DissolveVertical *vertical;
	DissolveHorizontal *horizontal;
	DissolveRadius *radius;
};

class DissolveRadius : public BC_IPot
{
public:
	DissolveRadius(DissolveMain *client, int x, int y);
	~DissolveRadius();
	int handle_event();

	DissolveMain *client;
};

class DissolveVertical : public BC_CheckBox
{
public:
	DissolveVertical(DissolveMain *client, DissolveWindow *window, int x, int y);
	~DissolveVertical();
	int handle_event();

	DissolveMain *client;
	DissolveWindow *window;
};

class DissolveHorizontal : public BC_CheckBox
{
public:
	DissolveHorizontal(DissolveMain *client, DissolveWindow *window, int x, int y);
	~DissolveHorizontal();
	int handle_event();

	DissolveMain *client;
	DissolveWindow *window;
};


#endif
