#include "mwindow.h"
#include "part.h"
#include "position.h"
#include "rocket.h"

#include <GL/glut.h>
#include <stdio.h>

Rocket::Rocket(MWindow *mwindow)
{
	position = new Position;
	this->mwindow = mwindow;
}

Rocket::~Rocket()
{
	delete position;
	parts.remove_all_objects();
}

void Rocket::add_part(Part *part)
{
	Part *new_part;
	parts.append(new_part = new Part(mwindow));
	*new_part = *part;
}

void Rocket::draw()
{
	for(int i = 0; i < parts.total; i++)
	{
		Part *part = parts.values[i];
  		glPushMatrix();
		part->position->translate_rotate();
		part->draw();
	    glPopMatrix();
	}
}

Rocket& Rocket::operator=(Rocket& that)
{
	parts.remove_all_objects();
	for(int i = 0; i < that.parts.total; i++)
	{
		parts.append(that.parts.values[i]->make_copy());
	}

	for(int i = 0; i < MAX_SETS; i++)
	{
		engine_sets[i].remove_all();
		for(int j = 0; j < that.engine_sets[i].total; j++)
			engine_sets[i].append(that.engine_sets[i].values[j]);
		part_sets[i].remove_all();
		for(int j = 0; j < that.part_sets[i].total; j++)
			part_sets[i].append(that.part_sets[i].values[j]);
	}
	

	*position = *that.position;
}

