#ifndef MWINDOW_H
#define MWINDOW_H

#include "arraylist.h"
#include "buildwindow.inc"
#include "launchwindow.inc"
#include "part.inc"
#include "partwindow.inc"
#include "planet.inc"
#include "position.inc"
#include "rocket.inc"
#include "subwindow.inc"
#include "texture.inc"

class MWindow
{
public:
	MWindow();
	~MWindow();
	
	void create_objects(int ac, char **av);
	void load_planets();
	void load_rocket();
	void load_parts();
	void load_textures();

	void init_light();
	void main_loop();
	static void reshape_event(int w, int h);
	static void draw_event();
	static void keypress_event(unsigned char k, int x, int y);
	static void keypress_event2(int k, int x, int y);
	static void button_event(int button, int state, int x, int y);
	static void motion_event(int x, int y);
	void keypress(unsigned char k);
	void keypress2(int k);
	void reshape(int w, int h);
	void button_release(int x, int y);
	void button_press(int x, int y);
	void cursor_motion(int x, int y);
	void draw();
	void draw_base();
	void draw_light();
	int text_height();
	int text_width(char *string);
	void set_font(void *font);
	void draw_center_text(int x, int y, char *string);
	void draw_text(int x, int y, char *string);
	void draw_planets();
	void draw_part(Part *part);
	void draw_part_selection();
	void begin_text();
	void end_text();
	void draw_help();
	void draw_overlays();
	void set_color(int color);
// Observation for build and fly
	void set_observation();
// Observation for part selection
	void part_observation(Part *part);
	void draw_rocket(Rocket *rocket);

	int width, height;
// Observation point relative to rocket
	Position *position;
// Observation point relative to part selection
	double part_obs[3];
	int show_help;
	int mode;
// Part being viewed in NEWPART
	int selected_part;
// Pointer to part selected in BUILD
	Part *new_part;
	int button_state, which_button;
// Last coords of mouse position
	int last_x, last_y;
// Kayboard modifiers
	int modifiers;
	void *font;

	SubWindow *current_window;
	PartWindow *pwindow;
	BuildWindow *bwindow;
	LaunchWindow *lwindow;

// Rocket being built
	Rocket *rocket;
// Rocket being launched
	Rocket *rocket2;
// Solar system
	ArrayList<Planet*> planets;
// Default parts
	ArrayList<Part*> default_parts;
// Textures
	Texture *flame1;
	double light_matrix[16];
};

extern MWindow *mwindow;

#endif
