#ifndef PART_H
#define PART_H

#include "mwindow.inc"
#include "position.inc"

class Part
{
public:
	Part(MWindow *mwindow);
	virtual ~Part();
	virtual Part* make_copy() { return 0; };
	
	Part& operator=(Part &that);
	virtual void draw() {};

	char title[1024];
	double max_thrust;         // N
	double fuel_qty;           // kg
	double dry_weight;         // kg
	double specific_impulse;   // s
	int use_throttle;
	int use_pulse;
	int nonstop;

// Current throttle position
	double throttle;
	Position *position;
	MWindow *mwindow;
	int highlighted;
// toggle flame
	int flame_position;
};

#endif
