#ifndef POSITION_H
#define POSITION_H

class Position
{
public:
	Position();
	~Position();

	Position& operator=(Position& that);
	Position& operator+=(Position& that);
	void translate_rotate();
	void trackball_action(int which_button, int last_x, int last_y, int x, int y);
	void translation_action(int which_button, int last_x, int last_y, int x, int y);

// Order x, y, z or rho, phi, theta
	static void sphere_to_cart(double *coords);
	static void cart_to_sphere(double *coords);
	static double dot_product(double *a, double *b);
	static void cross_product(double *c, double *a, double *b);
	static void update_phi_sign(double &phi_sign, double phi);
	static void normalize(double *coords);
	void dump();


// Position vector: x, y, z
	double pos[3];
// Direction vector: x, y, z, w
	double dir[4];
	double phi_sign;
};

#endif
