#include "shuttletank.h"

#include "mwindow.h"

#include <stdio.h>

#define RADIUS (8.41248 / 2 * SCALE)
#define CONE_H (9.144 * SCALE)
#define TUBE_H (37.73424 * SCALE)

ShuttleTank::ShuttleTank(MWindow *mwindow)
 : Part(mwindow)
{
	sprintf(title, "Shuttle fuel tank");
	max_thrust = 0;
	fuel_qty = 725747.792;   // kg
	dry_weight = 29937.1;  // kg

	GLUquadricObj *q = gluNewQuadric();
	CylinderObj = glGenLists(1);
	glNewList(CylinderObj, GL_COMPILE);
/* cylinder */
	gluQuadricNormals(q, GL_SMOOTH);
	gluQuadricTexture(q, GL_TRUE);
	gluCylinder(q, RADIUS, RADIUS, TUBE_H, 24, 1);

/* end cap */
// 	glTranslatef(0.0, 0.0, TUBE_H);
 	gluDisk(q, 0.0, RADIUS, 24, 1);

// /* other end cap */
// 	glTranslatef(0.0, 0.0, -2.0);
// 	gluQuadricOrientation(q, GLU_INSIDE);
// 	gluDisk(q, 0.0, RADIUS, 24, 1);

	glEndList();
	gluDeleteQuadric(q);
}

Part* ShuttleTank::make_copy()
{
	ShuttleTank *result = new ShuttleTank(mwindow);
	*result = *this;
	return result;
}

void ShuttleTank::draw()
{
	mwindow->set_color(highlighted ? 0xFFFF00 : 0xFF0000);
	
    glPushMatrix();
	glutSolidCone(RADIUS, CONE_H, 24, 1);
    glTranslatef(0, 0, -TUBE_H);
	
	glCallList(CylinderObj);
    glPopMatrix();
}
