#ifndef LABEL_H
#define LABEL_H


#include "edl.inc"
#include "guicast.h"
#include "filexml.inc"
#include "labels.inc"
#include "mwindow.inc"
#include "recordlabel.inc"
#include "stringfile.inc"
#include "timebar.inc"

#define LABELSIZE 15

class LabelToggle : public BC_Label
{
public:
	LabelToggle(MWindow *mwindow, Label *label, int x, int y, long position);
	~LabelToggle();
	
	int handle_event();
	MWindow *mwindow;
	Label *label;
};

class Label : public ListItem<Label>
{
public:
	Label(EDL *edl, Labels *labels, long position);
	Label();
	~Label();

// REMOVE
	int create_objects(MWindow *mwindow, Labels *labels, long position_); // limitation of link list
// REMOVE
	int draw();

	int samplemovement();
	int get_pixel(long position);       // get pixel of label on screen

// REMOVE
	MWindow *mwindow;

// REMOVE
	LabelToggle *toggle;



	EDL *edl;
	Labels *labels;
// Seconds
	double position;
};

class Labels : public List<Label>
{
public:
	Labels(EDL *edl, char *xml_tag);
	virtual ~Labels();

	void dump();

	Labels& operator=(Labels &that);
	void copy_from(Labels *labels);
	int toggle_label(long start, long end);
    int equivalent(long position1, long position2);
	int flip_vertical();
	int draw();
	int samplemovement();
	int resize_event(int x);
	int delete_all();
	int save(FileXML *xml);
	int load(FileXML *xml, unsigned long load_flags);
	void insert_labels(Labels *labels, long start);

	int modify_handles(long oldposition, 
		long newposition, 
		int currentend, 
		int handle_mode);
	int copy(double start, double end, FileXML *xml);
	int copy_length(long start, long end); // return number of Labels in selection
	int insert(long start, long lengthsamples);
	int paste(long start, long end, long total_length, FileXML *xml);
	int paste_output(long startproject, long endproject, long startsource, long endsource, RecordLabels *labels);
// Setting follow to 1 causes labels to move forward after clear.
// Setting it to 0 implies ignoring the labels follow edits setting.
	int clear(long start, long end, int follow = 1);
	int paste_silence(long start, long end);
	int optimize();  // delete duplicates

	Label* label_of(long position); // first label on or after position
	MWindow *mwindow;
	TimeBar *timebar;
	EDL *edl;
	char *xml_tag;
};

#endif
