#ifndef LOCALSESSION_H
#define LOCALSESSION_H

#include "bcwindowbase.inc"
#include "defaults.inc"
#include "edl.inc"
#include "filexml.inc"



// Unique session for every EDL

class LocalSession
{
public:
	LocalSession(EDL *edl);
	~LocalSession();






	void copy_from(LocalSession *that);
	void save_xml(FileXML *file);
	void load_xml(FileXML *file);
	int load_defaults(Defaults *defaults);
	int save_defaults(Defaults *defaults);

	void boundaries();


	EDL *edl;


// Variables specific to each EDL
// The reason why selection ranges and inpoints have to be separate:
// The selection position has to change to set new in points.
// For editing functions whether inpoints or selection ranges are used
// depends on the editing mode.
	double selectionstart, selectionend;
	double in_point, out_point;
// Number of samples if pasted from a clipboard.
// If 0 use longest track
	double clipboard_length;
// Title if clip
	char clip_title[BCTEXTLEN];
	char clip_notes[BCTEXTLEN];
// Folder in parent EDL of clip
	char folder[BCTEXTLEN];
};

#endif
