#include "arraylist.h"
#include "filexml.h"
#include "filesystem.h"
#include "loadfile.inc"
#include "mainmenu.h"
#include "mwindow.h"
#include "mwindowgui.h"
#include "pluginserver.h"
#include "preferences.h"
#include <stdlib.h>
#include <string.h>








int main(int argc, char *argv[])
{
	fprintf(stderr, PROGRAM_NAME " (C)2001 Adam Williams\n");

// handle command line arguments first
	srand(time(0));
	ArrayList<char*> filenames;
	FileSystem fs;
	FileXML script('(', ')');
	char display[1024];
	display[0] = 0;
	
	int playback = 0;
	int record = 0;
	int want_gui = 1;
	int run_script = 0;
	int result = 0;

	for(int i = 1; i < argc; i++)
	{
		if(!strcmp(argv[i], "-h"))
		{                     // help
//			printf("Usage:\n");
//			printf("%s [-b script]\n", argv[0]);
//			exit(0);
		}
		else
		if(!strcmp(argv[i], "-b"))
		{
printf("Scipted recording is no longer available.  Use Batch Capture.\n");
// 			i++;
// 			if(i < argc)
// 			{
// 				script.read_from_file(argv[i]);
// 				run_script = 1;
// 			}
// 			else
// 			{
// 				printf("-b expects a script filename to run\n");
// 				exit(1);
// 			}
		}
		else
		if(!strcmp(argv[i], "-play"))
		{
			playback = 1;
			want_gui = 0;
		}
		else
		if(!strcmp(argv[i], "-record"))
		{
			record = 1;
			want_gui = 0;
		}
		else
		if(!strcmp(argv[i], "-display") && i + 1 < argc)
		{
			strcpy(display, argv[i + 1]);
			i++;
		}
		else
		{
			char *new_filename;
			new_filename = new char[1024];
			strcpy(new_filename, argv[i]);
            fs.complete_path(new_filename);

			filenames.append(new_filename);
		}
	}

// create the main window
	MWindow mwindow;
	mwindow.create_objects(want_gui, !filenames.total);

	if(filenames.total && want_gui)
	{
// load the initial files on seperate tracks
		mwindow.gui->lock_window();
		mwindow.load_filenames(&filenames, LOAD_REPLACE);
		if(filenames.total == 1) 
			mwindow.gui->mainmenu->add_load(filenames.values[0]);
		mwindow.gui->unlock_window();
	}

// 	if(playback)
// 	{
// // load and play files one at a time
// 		for(int i = 0; i < filenames.total; i++)
// 		{
// 			mwindow.load(filenames.values[i], 0);
// 			mwindow.set_playback_range();
// 			mwindow.arm_playback(0, 0, 0, 0);
// 			mwindow.start_playback();
// 			mwindow.wait_for_playback();
// 			mwindow.is_playing_back = 0;
// 		}
// 	}
// 	
// 	if(record)
// 	{
// // Start the record engine with default parameters.
// 	}

	if(want_gui)
	{
// run the program
		if(run_script) 
			result = mwindow.run_script(&script);

		mwindow.gui->run_window();
		mwindow.save_defaults();
	}

// delete char strings
	for(int i = 0; i < filenames.total; i++) delete filenames.values[i];
}

